#include "calculator.h"
#include "subprogram.h"

extern vector <Dir> dir;
extern vector <string> dirimage;
extern SDL_Surface *img_text, *img_background, *img_arrow, *img_arrows, *img_dirbuttons, *img_editbuttons, *img_check, *img_doc, *img_dot, *img_folder, *img_music, *img_pic, *img_space, *screen, *im_screen;
extern SDL_Surface *img_rckeys, *img_lckeys, *img_lcskeys, *img_rcskeys, *img_lkeys, *img_rkeys, *img_lskeys, *img_rskeys, *img_calckeys;
extern SDL_Surface *img_textbackground, *tmp, *img_view, *img_test, *img_menubar;
extern TTF_Font *font, *drawfont, *drawfont10, *drawfont12, *drawfont14, *drawfont16, *systemfont;
extern SDL_Color sdlwhite;
extern SDL_Color sdlblack;
extern SDL_Color sdlgrey;
extern SDL_Color sdldarkgrey;
extern SDL_Color sdlred;
extern SDL_Color sdlgreen;
extern SDL_Color sdlblue;
extern SDL_Color forecol, fgcol, bgcol;
extern Uint32 backcol, white, black, grey, lightgrey, darkgrey, red, green, blue, cursorcol;
extern string readfile, currentdir;
extern bool bmUpdate, isplaying, ispaused, padrelease, usb, shift, caps,transition;
extern int nLine,nCol,wait, lx, ly, rx, ry;
extern int menu,dirselect, mode, nKeyset, nFontsize, menucursor;
int submenu, submenucursor, submenu2, submenucursor2, subselect;
extern SceCtrlData pad;
extern int blx,bly,blh;

extern struct p_sp_Key newKey;
extern SDL_Surface *img_buttongroup1a, *img_buttongroup2a;

using namespace calc_load ;
typedef Calculator<double> CALC;
CALC ee;
string expression;
int calcscroll = 0, calcselect = 0;
static int inputcursor;
vector <string> eList;
vector <string> aList;
vector <string> parse;
double result;

void drawCalcKeyboard(SDL_Surface *surface) {
	if (nKeyset != 4)
	{
		if (!shift and !caps and !shift) {
			sge_Blit(img_lkeys, surface, 0,0,0,200,img_lkeys->w, img_lkeys->h);
			sge_Blit(img_rkeys, surface, 0,0,180,200,img_rkeys->w, img_rkeys->h);
		}
		if ((shift or shift) and !caps) {
			sge_Blit(img_lskeys, surface, 0,0,0,200,img_lskeys->w, img_lskeys->h);
			sge_Blit(img_rskeys, surface, 0,0,180,200,img_rskeys->w, img_rskeys->h);
		}
		if (caps and !shift and !shift) {	
			sge_Blit(img_lckeys, surface, 0,0,0,200,img_lckeys->w, img_lckeys->h);
			sge_Blit(img_rckeys, surface, 0,0,180,200,img_rckeys->w, img_rckeys->h);
		}
		if ((shift or shift) and caps) {
			sge_Blit(img_lcskeys, surface, 0,0,0,200,img_lcskeys->w, img_lcskeys->h);
			sge_Blit(img_rcskeys, surface, 0,0,180,200,img_rcskeys->w, img_rcskeys->h);
		}
		sge_Blit(img_space, surface, 0,0, 160, 200, img_space->w, img_space->h);
		blit(surface,340,200,img_calckeys);
		drawRect(surface, (lx) * 20, 200 + (ly) * 18, 20, 18, blue);
		if (nKeyset == 3) drawRect(surface, 160 + (rx) * 20, 200 + (ry) * 18, 20, 18, red);
	}
	if (nKeyset == 4)
	{
		if (newKey.keygroup == 0) blit(surface, 138, 200,img_buttongroup1a);
		if (newKey.keygroup == 1) blit(surface, 138, 200,img_buttongroup2a);
	}	
}

void initCalculatorMenu(void)
{
	subselect = 0;
	submenu = 1;
	submenu2 = 1;
	submenucursor = 1;
	submenucursor2 = 1;
}
void initCalculator(void) {
	expression.clear();
	calcscroll = 0;
	inputcursor = 0;
}

void getCalculatorInput(void) 
{
	int findfirst, findlast;
	char sizestring[256];
	string textscroll, readkey;

	readKeyboard();
	readkey = readKey();
# ifdef USE_PSP_IRKEYB
  if (readkey == "ed") {
    readkey = "";
  }
# endif
	
	if (padUp()) {
		if (calcscroll > 0) {
			calcscroll--;
		}
		if (calcselect > 0) {
			calcselect--;
		}
		wait = 120;
		bmUpdate = true;
	}
	
	if (padDown()) {
		if (calcscroll + 4 < eList.size()) {
			calcscroll++;
		}
		if (calcselect < eList.size()-1) calcselect++;
		wait = 120;
		bmUpdate = true;
	}	

	
	if (padLeft()) {
		if (inputcursor > 0) {
			inputcursor--;
			wait = 120;
			bmUpdate = true;
		}
	}
	
	if (padRight()) {
		if (inputcursor < expression.size()) {
			inputcursor++;
			wait = 120;
			bmUpdate = true;
		}
	}
	if (readkey != "") {
		if (readkey == "bs") {
			if (inputcursor > 0 && expression.size() > 0) {
				expression.erase(inputcursor-1,1);
				inputcursor--;
			}
		}
		else if (readkey == "en") {
			if (expression.size() > 0) {
				bool error = ee.parse(expression.c_str()) ;
				if ( error ) {
					string error;
					ee.report_error(error) ;
					//sprintf(sizestring,"Error evaluating expression");
					textscroll = "Error: " + error;
				}
				else {
					result = ee.get_value();
					sprintf(sizestring,"a=%f",result);
					ee.parse(sizestring);
					sprintf(sizestring, "%f", result );
					textscroll = sizestring;
				}
				
				findfirst = textscroll.find(".00000",0);
				if (findfirst != string::npos) textscroll = textscroll.substr(0,findfirst);
				else {
					findfirst = textscroll.find(".",0);
					if (findfirst != string::npos) {
						findlast = textscroll.find("0000",findfirst);
						if (findlast != string::npos) textscroll = textscroll.substr(0,findlast);
					}
				}
				eList.push_back(expression);
				aList.push_back(textscroll);
				expression.clear();
				if (eList.size() > 4) calcscroll = eList.size() - 4;
				calcselect = eList.size()-1;
				inputcursor = 0;
			}
			else if (eList.size() > 0) {
				expression = eList[calcselect];
				inputcursor = expression.size();
			}
			transition = true;
		}
		else if (expression.size() < 256) {
				expression.insert(inputcursor,readkey);
				if (readkey == "pi") inputcursor++;
				else if (readkey.size() > 1) inputcursor += readkey.size()-2;
				inputcursor++;
			}
		
		bmUpdate = true;
	}
}

void displayCalculator(void) {
	string textscroll;
	int count;
	
	blit(im_screen,0,0, img_background);
	drawCalcKeyboard(im_screen);
	drawMenuFrame(im_screen);
	
	drawText(font,im_screen,205,17,"Calculator", sdlblack);
	
	drawFillRect(im_screen,26,28,428,10,lightgrey);
	drawHline(im_screen,26,37,428,darkgrey);
	drawText(font,im_screen,35,27, "History", sdlblack);
	
	for (count = calcscroll; count < eList.size(); count++) {
		if (eList[count].size() > 60) textscroll = eList[count].substr(0,60);
		else textscroll = eList[count];
		if (count - calcscroll < 4) {
			if (count == calcselect) {
				if (eList[count].size() <= 60) drawFillRect(im_screen,29,39+2*(count-calcscroll)*nLine,eList[count].size()*nCol+2,nLine+1,lightgrey);
				else drawFillRect(im_screen,29,39+2*(count-calcscroll)*nLine,60*nCol+2,nLine+1,lightgrey);
			}
			drawText(font,im_screen,30,40+2*(count-calcscroll)*nLine, textscroll, sdldarkgrey);
			
		}
	}
	
	for (count = calcscroll; count < aList.size(); count++) {
		if (aList[count].size() > 54) textscroll = aList[count].substr(0,54);
		else textscroll = aList[count];
		if (count - calcscroll < 4) {
			drawText(font,im_screen,72,52+2*(count-calcscroll)*nLine, textscroll, sdlblack);
		}
	}
	
	drawFillRect(im_screen,26,138,428,10,lightgrey);
	drawHline(im_screen,26,138,428,darkgrey);
	drawText(font,im_screen,35,137, "Input", sdlblack);
	
	if (expression.size() > 60) {
		if (inputcursor < expression.size() - 60) textscroll = expression.substr(inputcursor,60);
		else textscroll = expression.substr(expression.size()-60);
	}
	else textscroll = expression;
	drawText(font,im_screen,30,149, textscroll.c_str(), sdlblack);
	//drawVline(im_screen,30+textscroll.size()*nCol, 148, nLine, cursorcol);
	if (expression.size() <= 60) blx = 30+inputcursor*nCol;
	else {
		if (inputcursor < expression.size() - 60) blx = 30;
		else blx = 30+(60)*nCol-expression.size()*nCol+inputcursor*nCol;
	}
	bly = 148;
	blh = nLine;
}

void getCalculatorMenuInput(void) {
	string textscroll;
	
	if (padrelease) {
		if (pad.Buttons & PSP_CTRL_RIGHT) {
			if (subselect == 2) {
				menu = 1;
				subselect = 0;
				submenu = 0;
				submenu2 = 0;
				menucursor = 1;
			}
			else subselect++;
			wait = 100;
			padrelease = false;
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_LEFT) {
			if (subselect == 0) {
				menu = 4;
				menucursor = 1;
				submenu = 0;
				submenu2 = 0;
			}
			else subselect--;
			wait = 100;
			padrelease = false;
			bmUpdate = true;
		}
	}
	if (pad.Buttons & PSP_CTRL_UP) {
		if (subselect == 0) {
			if (menucursor == 1) menucursor = 5;
			else menucursor--;
			submenu = menucursor;
			submenu2 = menucursor;
			submenucursor = 1;
			submenucursor2 = 1;
		}
		else if (subselect == 1) {
				if (submenucursor == 1) {
					if (submenu = 1) submenucursor = 8;
					if (submenu = 2) submenucursor = 4;
					if (submenu = 3) submenucursor = 3;
					if (submenu = 4) submenucursor = 5;
					if (submenu = 5) submenucursor = 3;
				}
				else submenucursor--;
			}
			else if (subselect == 2) {
				if (submenucursor2 == 1) {
					if (submenu = 1) submenucursor2 = 8;
					if (submenu = 2) submenucursor2 = 4;
					if (submenu = 3) submenucursor2 = 3;
					if (submenu = 4) submenucursor2 = 5;
					if (submenu = 5) submenucursor2 = 3;
				}
				else submenucursor2--;
			}
				
		wait = 100;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_DOWN) {
		if (subselect == 0) {
			if (menucursor == 5) menucursor = 1;
			else menucursor++;
			submenu = menucursor;
			submenu2 = menucursor;
			submenucursor = 1;
			submenucursor2 = 1;
		}
		else if (subselect == 1) {
					if (submenu == 1 && submenucursor == 8) submenucursor = 1;
					else if (submenu == 2 && submenucursor == 4) submenucursor = 1;
					else if (submenu == 3 && submenucursor == 3) submenucursor = 1;
					else if (submenu == 4 && submenucursor == 5) submenucursor = 1;
					else if (submenu == 5 && submenucursor == 3) submenucursor = 1;
					else submenucursor++;
			}
			else if (subselect == 2) {
					if (submenu == 1 && submenucursor2 == 8) submenucursor2 = 1;
					else if (submenu == 2 && submenucursor2 == 4) submenucursor2 = 1;
					else if (submenu == 3 && submenucursor2 == 3) submenucursor2 = 1;
					else if (submenu == 4 && submenucursor2 == 5) submenucursor2 = 1;
					else if (submenu == 5 && submenucursor2 == 3) submenucursor2 = 1;
					else submenucursor2++;
			}
				
		wait = 100;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_CROSS) {
		if (submenucursor != submenucursor2) {
			textscroll = getFunction(submenu,submenucursor,submenucursor2);
			expression.insert(inputcursor,textscroll);
			inputcursor+=textscroll.size()-1;
			wait = 100;
			bmUpdate = true;
			submenu = 0;
			submenu2 = 0;
			menu = 0;
			transition = true;
		}
	}
}			

void displayCalculatorMenu(void) {
	int menupos;
	int submenupos,count;
	
	if (menu > 0 && mode == CALCULATOR) {
		blit(im_screen, 0,0, img_menubar);
		if (menu == 1) {
			drawFillRect(im_screen,8,0,32,10,darkgrey);
		}
		if (menu == 3) {
			drawFillRect(im_screen,58,0,32,10,darkgrey);
		}
		if (menu == 4) {
			drawFillRect(im_screen,108,0,39,10,darkgrey);
		}
		if (menu == 6) {
			drawFillRect(im_screen,158,0,81,10,darkgrey);
		}
		drawText(font,im_screen,11,0, "File", sdlblack);
		drawText(font,im_screen,61,0, "View", sdlblack);
		if (isplaying) drawText(font,im_screen,111,0, "Music", sdlblack);
		else drawText(font,im_screen,111,0, "Music", sdldarkgrey);
		drawText(font,im_screen,161,0, "Conversions", sdlblack);
	}		
	
	if (menu == 6) {
		menupos = 55;
		
		drawText(font,im_screen,161,0, "Conversions", sdlwhite);
		
		drawDropmenu(im_screen, menupos, 11, 11, 5);

		if (subselect == 0 ) drawFillRect(im_screen,menupos+6,menucursor*nLine+4, 4*nCol+nCol*11-8, nLine, blue);
		else drawFillRect(im_screen,menupos+6,menucursor*nLine+4, 4*nCol+nCol*11-8, nLine, darkgrey);
		
		if (menucursor == 1) drawTextShadowed(font,im_screen,menupos+20, nLine+4, "Length", sdlwhite);
		else drawText(font,im_screen,menupos+20, nLine+4, "Length", sdlblack);
		
		if (menucursor == 2) drawTextShadowed(font,im_screen,menupos+20, 2*nLine+4, "Mass", sdlwhite);
		else drawText(font,im_screen,menupos+20, 2*nLine+4, "Mass", sdlblack);
		
		if (menucursor == 3) drawTextShadowed(font,im_screen,menupos+20, 3*nLine+4, "Time", sdlwhite);
		else drawText(font,im_screen,menupos+20, 3*nLine+4, "Time", sdlblack);
		
		if (menucursor == 4) drawTextShadowed(font,im_screen,menupos+20, 4*nLine+4, "Velocity", sdlwhite);
		else drawText(font,im_screen,menupos+20, 4*nLine+4, "Velocity", sdlblack);

		if (menucursor == 5) drawTextShadowed(font,im_screen,menupos+20, 5*nLine+4, "Temperature", sdlwhite);
		else drawText(font,im_screen,menupos+20, 5*nLine+4, "Temperature", sdlblack);

		for (count = 1; count < 6; count++) {
			blit(im_screen,menupos+6+4*nCol+nCol*11-13,count*nLine+5,img_arrow);
		}			
	}
	
	if (submenu == 1) {
		submenupos = 164;
		drawDropmenu(im_screen, submenupos, 11, 15, 8);
		if (subselect == 1) drawFillRect(im_screen,submenupos+6,submenucursor*nLine+4, 4*nCol+nCol*15-8, nLine, blue);
		else drawFillRect(im_screen,submenupos+6,submenucursor*nLine+4, 4*nCol+nCol*15-8, nLine, darkgrey);

		if (submenucursor == 1) drawTextShadowed(font,im_screen,submenupos+20, nLine+4, "inches (in)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, nLine+4, "inches (in)", sdlblack);
		
		if (submenucursor == 2) drawTextShadowed(font,im_screen,submenupos+20, 2*nLine+4, "feet (ft)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 2*nLine+4, "feet (ft)", sdlblack);
		
		if (submenucursor == 3) drawTextShadowed(font,im_screen,submenupos+20, 3*nLine+4, "yard (yd)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 3*nLine+4, "yard (yd)", sdlblack);
		
		if (submenucursor == 4) drawTextShadowed(font,im_screen,submenupos+20, 4*nLine+4, "mile (mile)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 4*nLine+4, "mile (mile)", sdlblack);

		if (submenucursor == 5) drawTextShadowed(font,im_screen,submenupos+20, 5*nLine+4, "millimeter (mm)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 5*nLine+4, "millimeter (mm)", sdlblack);
		
		if (submenucursor == 6) drawTextShadowed(font,im_screen,submenupos+20, 6*nLine+4, "centimeter (cm)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 6*nLine+4, "centimeter (cm)", sdlblack);

		if (submenucursor == 7) drawTextShadowed(font,im_screen,submenupos+20, 7*nLine+4, "meter (m)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 7*nLine+4, "meter (m)", sdlblack);

		if (submenucursor == 8) drawTextShadowed(font,im_screen,submenupos+20, 8*nLine+4, "kilometer (km)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 8*nLine+4, "kilometer (km)", sdlblack);			

		for (count = 1; count < 9; count++) {
			blit(im_screen,submenupos+6+4*nCol+nCol*15-13,count*nLine+5,img_arrow);
		}				
	}
	if (submenu2 == 1) {
		submenupos = 301;
		drawDropmenu(im_screen, submenupos, 11, 15, 8);
		if (subselect == 2) drawFillRect(im_screen,submenupos+6,submenucursor2*nLine+4, 4*nCol+nCol*15-8, nLine, blue);
		else drawFillRect(im_screen,submenupos+6,submenucursor2*nLine+4, 4*nCol+nCol*15-8, nLine, darkgrey);

		if (submenucursor2 == 1) drawTextShadowed(font,im_screen,submenupos+20, nLine+4, "inches (in)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, nLine+4, "inches (in)", sdlblack);
		
		if (submenucursor2 == 2) drawTextShadowed(font,im_screen,submenupos+20, 2*nLine+4, "feet (ft)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 2*nLine+4, "feet (ft)", sdlblack);
		
		if (submenucursor2 == 3) drawTextShadowed(font,im_screen,submenupos+20, 3*nLine+4, "yard (yd)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 3*nLine+4, "yard (yd)", sdlblack);
		
		if (submenucursor2 == 4) drawTextShadowed(font,im_screen,submenupos+20, 4*nLine+4, "mile (mile)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 4*nLine+4, "mile (mile)", sdlblack);

		if (submenucursor2 == 5) drawTextShadowed(font,im_screen,submenupos+20, 5*nLine+4, "millimeter (mm)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 5*nLine+4, "millimeter (mm)", sdlblack);
		
		if (submenucursor2 == 6) drawTextShadowed(font,im_screen,submenupos+20, 6*nLine+4, "centimeter (cm)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 6*nLine+4, "centimeter (cm)", sdlblack);

		if (submenucursor2 == 7) drawTextShadowed(font,im_screen,submenupos+20, 7*nLine+4, "meter (m)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 7*nLine+4, "meter (m)", sdlblack);

		if (submenucursor2 == 8) drawTextShadowed(font,im_screen,submenupos+20, 8*nLine+4, "kilometer (km)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 8*nLine+4, "kilometer (km)", sdlblack);			
	}
	
	if (submenu == 2) {
		submenupos = 164;
		drawDropmenu(im_screen, submenupos, 11, 14, 4);
		if (subselect == 1) drawFillRect(im_screen,submenupos+6,submenucursor*nLine+4, 4*nCol+nCol*14-8, nLine, blue);
		else drawFillRect(im_screen,submenupos+6,submenucursor*nLine+4, 4*nCol+nCol*14-8, nLine, darkgrey);

		if (submenucursor == 1) drawTextShadowed(font,im_screen,submenupos+20, nLine+4, "pounds (lb)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, nLine+4, "pounds (lb)", sdlblack);
		
		if (submenucursor == 2) drawTextShadowed(font,im_screen,submenupos+20, 2*nLine+4, "ounce (oz)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 2*nLine+4, "ounce (oz)", sdlblack);
		
		if (submenucursor == 3) drawTextShadowed(font,im_screen,submenupos+20, 3*nLine+4, "grams (g)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 3*nLine+4, "grams (g)", sdlblack);
		
		if (submenucursor == 4) drawTextShadowed(font,im_screen,submenupos+20, 4*nLine+4, "kilograms (kg)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 4*nLine+4, "kilograms (kg)", sdlblack);			
		
		for (count = 1; count < 5; count++) {
			blit(im_screen,submenupos+6+4*nCol+nCol*14-13,count*nLine+5,img_arrow);
		}				
	}
	
	if (submenu2 == 2) {
		submenupos = 294;
		drawDropmenu(im_screen, submenupos, 11, 14, 4);
		if (subselect == 2) drawFillRect(im_screen,submenupos+6,submenucursor2*nLine+4, 4*nCol+nCol*14-8, nLine, blue);
		else drawFillRect(im_screen,submenupos+6,submenucursor2*nLine+4, 4*nCol+nCol*14-8, nLine, darkgrey);

		if (submenucursor2 == 1) drawTextShadowed(font,im_screen,submenupos+20, nLine+4, "pounds (lb)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, nLine+4, "pounds (lb)", sdlblack);
		
		if (submenucursor2 == 2) drawTextShadowed(font,im_screen,submenupos+20, 2*nLine+4, "ounce (oz)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 2*nLine+4, "ounce (oz)", sdlblack);
		
		if (submenucursor2 == 3) drawTextShadowed(font,im_screen,submenupos+20, 3*nLine+4, "grams (g)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 3*nLine+4, "grams (g)", sdlblack);
		
		if (submenucursor2 == 4) drawTextShadowed(font,im_screen,submenupos+20, 4*nLine+4, "kilograms (kg)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 4*nLine+4, "kilograms (kg)", sdlblack);			
	}
	
	if (submenu == 3) {
		submenupos = 164;
		drawDropmenu(im_screen, submenupos, 11, 12, 3);
		if (subselect == 1) drawFillRect(im_screen,submenupos+6,submenucursor*nLine+4, 4*nCol+nCol*12-8, nLine, blue);
		else drawFillRect(im_screen,submenupos+6,submenucursor*nLine+4, 4*nCol+nCol*12-8, nLine, darkgrey);

		if (submenucursor == 1) drawTextShadowed(font,im_screen,submenupos+20, nLine+4, "days (d)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, nLine+4, "days (d)", sdlblack);
		
		if (submenucursor == 2) drawTextShadowed(font,im_screen,submenupos+20, 2*nLine+4, "minute (min)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 2*nLine+4, "minute (min)", sdlblack);
		
		if (submenucursor == 3) drawTextShadowed(font,im_screen,submenupos+20, 3*nLine+4, "second (s)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 3*nLine+4, "second (s)", sdlblack);			

		for (count = 1; count < 4; count++) {
			blit(im_screen,submenupos+6+4*nCol+nCol*12-13,count*nLine+5,img_arrow);
		}				
	}
	
	if (submenu2 == 3) {
		submenupos = 280;
		drawDropmenu(im_screen, submenupos, 11, 12, 3);
		if (subselect == 2) drawFillRect(im_screen,submenupos+6,submenucursor2*nLine+4, 4*nCol+nCol*12-8, nLine, blue);
		else drawFillRect(im_screen,submenupos+6,submenucursor2*nLine+4, 4*nCol+nCol*12-8, nLine, darkgrey);

		if (submenucursor2 == 1) drawTextShadowed(font,im_screen,submenupos+20, nLine+4, "days (d)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, nLine+4, "days (d)", sdlblack);
		
		if (submenucursor2 == 2) drawTextShadowed(font,im_screen,submenupos+20, 2*nLine+4, "minute (min)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 2*nLine+4, "minute (min)", sdlblack);
		
		if (submenucursor2 == 3) drawTextShadowed(font,im_screen,submenupos+20, 3*nLine+4, "second (s)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 3*nLine+4, "second (s)", sdlblack);			
	}
	
	if (submenu == 4) {
		submenupos = 164;
		drawDropmenu(im_screen, submenupos, 11, 18, 5);
		if (subselect == 1) drawFillRect(im_screen,submenupos+6,submenucursor*nLine+4, 4*nCol+nCol*18-8, nLine, blue);
		else drawFillRect(im_screen,submenupos+6,submenucursor*nLine+4, 4*nCol+nCol*18-8, nLine, darkgrey);

		if (submenucursor == 1) drawTextShadowed(font,im_screen,submenupos+20, nLine+4, "mile/hr (mph)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, nLine+4, "mile/hr (mph)", sdlblack);
		
		if (submenucursor == 2) drawTextShadowed(font,im_screen,submenupos+20, 2*nLine+4, "meter/s (mps)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 2*nLine+4, "meter/s (mps)", sdlblack);
		
		if (submenucursor == 3) drawTextShadowed(font,im_screen,submenupos+20, 3*nLine+4, "foot/hr (fph)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 3*nLine+4, "foot/hr (fph)", sdlblack);
		
		if (submenucursor == 4) drawTextShadowed(font,im_screen,submenupos+20, 4*nLine+4, "kilometer/hr (kph)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 4*nLine+4, "kilometer/hr (kph)", sdlblack);

		if (submenucursor == 5) drawTextShadowed(font,im_screen,submenupos+20, 5*nLine+4, "knot (knot)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 5*nLine+4, "knot (knot)", sdlblack);			
		
		for (count = 1; count < 6; count++) {
			blit(im_screen,submenupos+6+4*nCol+nCol*18-13,count*nLine+5,img_arrow);
		}				
	}
	if (submenu2 == 4) {
		submenupos = 322;
		drawDropmenu(im_screen, submenupos, 11, 18, 5);
		if (subselect == 2) drawFillRect(im_screen,submenupos+6,submenucursor2*nLine+4, 4*nCol+nCol*18-8, nLine, blue);
		else drawFillRect(im_screen,submenupos+6,submenucursor2*nLine+4, 4*nCol+nCol*18-8, nLine, darkgrey);

		if (submenucursor2 == 1) drawTextShadowed(font,im_screen,submenupos+20, nLine+4, "mile/hr (mph)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, nLine+4, "mile/hr (mph)", sdlblack);
		
		if (submenucursor2 == 2) drawTextShadowed(font,im_screen,submenupos+20, 2*nLine+4, "meter/s (mps)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 2*nLine+4, "meter/s (mps)", sdlblack);
		
		if (submenucursor2 == 3) drawTextShadowed(font,im_screen,submenupos+20, 3*nLine+4, "foot/hr (fph)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 3*nLine+4, "foot/hr (fph)", sdlblack);
		
		if (submenucursor2 == 4) drawTextShadowed(font,im_screen,submenupos+20, 4*nLine+4, "kilometer/hr (kph)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 4*nLine+4, "kilometer/hr (kph)", sdlblack);

		if (submenucursor2 == 5) drawTextShadowed(font,im_screen,submenupos+20, 5*nLine+4, "knot (knot)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 5*nLine+4, "knot (knot)", sdlblack);			
	}
	if (submenu == 5) {
		submenupos = 164;
		drawDropmenu(im_screen, submenupos, 11, 14, 3);
		if (subselect == 1) drawFillRect(im_screen,submenupos+6,submenucursor*nLine+4, 4*nCol+nCol*14-8, nLine, blue);
		else drawFillRect(im_screen,submenupos+6,submenucursor*nLine+4, 4*nCol+nCol*14-8, nLine, darkgrey);

		if (submenucursor == 1) drawTextShadowed(font,im_screen,submenupos+20, nLine+4, "celsius (c)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, nLine+4, "celsius (c)", sdlblack);
		
		if (submenucursor == 2) drawTextShadowed(font,im_screen,submenupos+20, 2*nLine+4, "fahrenheit (f)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 2*nLine+4, "fahrenheit (f)", sdlblack);
		
		if (submenucursor == 3) drawTextShadowed(font,im_screen,submenupos+20, 3*nLine+4, "kelvin (k)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 3*nLine+4, "kelvin (k)", sdlblack);			
		
		for (count = 1; count < 4; count++) {
			blit(im_screen,submenupos+6+4*nCol+nCol*14-13,count*nLine+5,img_arrow);
		}				
	}
	
	if (submenu2 == 5) {
		submenupos = 294;
		drawDropmenu(im_screen, submenupos, 11, 14, 3);
		if (subselect == 2) drawFillRect(im_screen,submenupos+6,submenucursor2*nLine+4, 4*nCol+nCol*14-8, nLine, blue);
		else drawFillRect(im_screen,submenupos+6,submenucursor2*nLine+4, 4*nCol+nCol*14-8, nLine, darkgrey);

		if (submenucursor2 == 1) drawTextShadowed(font,im_screen,submenupos+20, nLine+4, "celsius (c)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, nLine+4, "celsius (c)", sdlblack);
		
		if (submenucursor2 == 2) drawTextShadowed(font,im_screen,submenupos+20, 2*nLine+4, "fahrenheit (f)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 2*nLine+4, "fahrenheit (f)", sdlblack);
		
		if (submenucursor2 == 3) drawTextShadowed(font,im_screen,submenupos+20, 3*nLine+4, "kelvin (k)", sdlwhite);
		else drawText(font,im_screen,submenupos+20, 3*nLine+4, "kelvin (k)", sdlblack);			
	}
}

static double intoft(double const & a) {
	return a/12.0;
}

static double intoyd(double const &a) {
	return a/36.0;
}

static double intomile(double const &a) {
	return a/63360.0;
}

static double intomm(double const &a) {
	return a*25.4;
}

static double intocm(double const &a) {
	return a*2.54;
}

static double intom(double const &a) {
	return a*0.0254;
}

static double intokm(double const &a) {
	return a*0.0000254;
}

static double fttoin(double const &a) {
	return a*12;
}

static double fttoyd(double const &a) {
	return a/3.0;
}

static double fttomile(double const &a) {
	return a/5280.0;
}

static double fttomm(double const &a) {
	return a*304.8;
}

static double fttocm(double const &a) {
	return a*30.48;
}

static double fttom(double const &a) {
	return a*0.3048;
}

static double fttokm(double const &a) {
	return a*0.0003048;
}

static double ydtoin(double const &a) {
	return a*36;
}

static double ydtoft(double const &a) {
	return a*3;
}

static double ydtomile(double const &a) {
	return a/1760.0;
}

static double ydtomm(double const &a) {
	return a*914.4;
}

static double ydtocm(double const &a) {
	return a*91.44;
}

static double ydtom(double const &a) {
	return a*0.9144;
}

static double ydtokm(double const &a) {
	return a*0.0009144;
}

static double miletoin(double const &a) {
	return a*63360;
}

static double miletoft(double const &a) {
	return a*5280;
}

static double miletoyd(double const &a) {
	return a*1760;
}

static double miletomm(double const &a) {
	return a*1609344;
}

static double miletocm(double const &a) {
	return a*160934.4;
}

static double miletom(double const &a) {
	return a*1609.344;
}

static double miletokm(double const &a) {
	return a*1.609344;
}

static double mmtoin(double const &a) {
	return a/25.4;
}

static double mmtoft(double const &a) {
	return a/304.8;
}

static double mmtoyd(double const &a) {
	return a/914.4;
}

static double mmtomile(double const &a) {
	return a/1609344;
}

static double mmtocm(double const &a) {
	return a/10.0;
}

static double mmtom(double const &a) {
	return a/1000.0;
}

static double mmtokm(double const &a) {
	return a/1000000.0;
}

static double cmtoin(double const &a) {
	return a/2.54;
}

static double cmtoft(double const &a) {
	return a/30.48;
}

static double cmtoyd(double const &a) {
	return a/91.44;
}

static double cmtomile(double const &a) {
	return a/160934.4;
}

static double cmtomm(double const &a) {
	return a*10;
}

static double cmtom(double const &a) {
	return a/100.0;
}

static double cmtokm(double const &a) {
	return a/100000.0;
}

static double mtoin(double const &a) {
	return a/0.0254;
}

static double mtoft(double const &a) {
	return a/0.3048;
}

static double mtoyd(double const &a) {
	return a/0.9144;
}

static double mtomile(double const &a) {
	return a/1609.344;
}

static double mtomm(double const &a) {
	return a*1000;
}

static double mtocm(double const &a) {
	return a*100;
}

static double mtokm(double const &a) {
	return a/1000.0;
}

static double kmtoin(double const &a) {
	return a/0.0000254;
}

static double kmtoft(double const &a) {
	return a/0.0003048;
}

static double kmtoyd(double const &a) {
	return a/0.0009144;
}

static double kmtomile(double const &a) {
	return a/1.609344;
}

static double kmtomm(double const &a) {
	return a*1000000;
}

static double kmtocm(double const &a) {
	return a*100000;
}

static double kmtom(double const &a) {
	return a*1000;
}

static double lbtooz(double const &a) {
	return a*16;
}

static double lbtog(double const &a) {
	return a*453.5924;
}

static double lbtokg(double const &a) {
	return a*0.4535924;
}

static double oztolb(double const &a) {
	return a/16.0;
}

static double oztog(double const &a) {
	return a*28.34592;
}

static double oztokg(double const &a) {
	return a*0.2834592;
}

static double gtolb(double const &a) {
	return a/453.5924;
}

static double gtooz(double const &a) {
	return a/28.34592;
}

static double gtokg(double const &a) {
	return a/1000.0;
}

static double kgtolb(double const &a) {
	return a/0.4535924;
}

static double kgtooz(double const &a) {
	return a/0.02834592;
}

static double kgtog(double const &a) {
	return a*1000;
}

static double dtomin(double const &a) {
	return a*1440;
}

static double dtos(double const &a) {
	return a*86400;
}

static double mintod(double const &a) {
	return a/1440.0;
}

static double mintos(double const &a) {
	return a*60;
}

static double stod(double const &a) {
	return a/86400.0;
}
static double stomin(double const &a) {
	return a/60.0;
}

static double mphtomps(double const &a) {
	return a*0.44704;
}

static double mphtofph(double const &a) {
	return a*5280;
}

static double mphtokph(double const &a) {
	return a*1.609344;
}

static double mphtoknot(double const &a) {
	return a*1609.344/1852.0;
}

static double mpstomph(double const &a) {
	return 3600*a/1609.344;
}

static double mpstofph(double const &a) {
	return 5280*3600*a/1609.344;
}

static double mpstokph(double const &a) {
	return a*3.6;
}

static double mpstoknot(double const &a) {
	return 3600*a/1852.0;
}

static double fphtomph(double const &a) {
	return a/5280.0;
}

static double fphtomps(double const &a) {
	return 1609.344*a/(5280*3600);
}

static double fphtokph(double const &a) {
	return 1.609344*a/5280.0;
}

static double fphtoknot(double const &a) {
	return a*1609.344/(1852*5280);
}

static double kphtomph(double const &a) {
	return a/1.609344;
}

static double kphtomps(double const &a) {
	return a*1000.0/3600.0;
}

static double kphtofph(double const &a) {
	return 5280*a/1.609344;
}

static double kphtoknot(double const &a) {
	return 1000.0*a/1852.0;
}

static double knottomph(double const &a) {
	return a*1852/1609.344;
}

static double knottomps(double const &a) {
	return 1852.0*a/3600.0;
}

static double knottofph(double const &a) {
	return a*1852*5280.0/1609.344;
}

static double knottokph(double const &a) {
	return 1852.0*a/1000.0;
}

static double ctof(double const &a) {
	return 1.8*a+32;
}

static double ctok(double const &a) {
	return a+273.15;
}

static double ftoc(double const &a) {
	return (a-32)/1.8;
}

static double ftok(double const &a) {
	return (a+459.67)/1.8;
}

static double ktoc(double const &a) {
	return a-273.15;
}

static double ktof(double const &a) {
	return a*1.8 - 459.67;
}

static double fact(double const &a) {
	double temp;
	
	if (a <= 1) return 1;
	else temp = a*fact(a-1);
	return temp;
}

void setfunctions(void) {
	ee . set_unary_fun("fact",fact);
	ee . set_unary_fun("intoft",intoft);
	ee . set_unary_fun("intoyd",intoyd);
	ee . set_unary_fun("intomile",intomile);
	ee . set_unary_fun("intomm",intomm);
	ee . set_unary_fun("intocm",intocm);
	ee . set_unary_fun("intom",intom);
	ee . set_unary_fun("intokm",intokm);
	ee . set_unary_fun("fttoin",fttoin);
	ee . set_unary_fun("fttoyd",fttoyd);
	ee . set_unary_fun("fttomile",fttomile);
	ee . set_unary_fun("fttomm",fttomm);
	ee . set_unary_fun("fttocm",fttocm);
	ee . set_unary_fun("fttom",fttom);
	ee . set_unary_fun("fttokm",fttokm);
	ee . set_unary_fun("ydtoin",ydtoin);
	ee . set_unary_fun("ydtoft",ydtoft);
	ee . set_unary_fun("ydtomile",ydtomile);
	ee . set_unary_fun("ydtomm",ydtomm);
	ee . set_unary_fun("ydtocm",ydtocm);
	ee . set_unary_fun("ydtom",ydtom);
	ee . set_unary_fun("ydtokm",ydtokm) ;
	ee . set_unary_fun("miletoin",miletoin);
	ee . set_unary_fun("miletoft",miletoft);
	ee . set_unary_fun("miletoyd",miletoyd);
	ee . set_unary_fun("miletomm",miletomm);
	ee . set_unary_fun("miletocm",miletocm);
	ee . set_unary_fun("miletom",miletom);
	ee . set_unary_fun("miletokm",miletokm);
	ee . set_unary_fun("mmtoin",mmtoin);
	ee . set_unary_fun("mmtoft",mmtoft);
	ee . set_unary_fun("mmtoyd",mmtoyd);
	ee . set_unary_fun("mmtomile",mmtomile);
	ee . set_unary_fun("mmtocm",mmtocm);
	ee . set_unary_fun("mmtom",mmtom);
	ee . set_unary_fun("mmtokm",mmtokm);
	ee . set_unary_fun("cmtoin",cmtoin);
	ee . set_unary_fun("cmtoft",cmtoft);
	ee . set_unary_fun("cmtoyd",cmtoyd);
	ee . set_unary_fun("cmtomile",cmtomile);
	ee . set_unary_fun("cmtomm",cmtomm);
	ee . set_unary_fun("cmtom",cmtom);
	ee . set_unary_fun("cmtokm",cmtokm);
	ee . set_unary_fun("mtoin",mtoin);
	ee . set_unary_fun("mtoft",mtoft);
	ee . set_unary_fun("mtoyd",mtoyd);
	ee . set_unary_fun("mtomile",mtomile);
	ee . set_unary_fun("mtomm",mtomm);
	ee . set_unary_fun("mtocm",mtocm);
	ee . set_unary_fun("mtokm",mtokm);		
	ee . set_unary_fun("kmtoin",kmtoin);
	ee . set_unary_fun("kmtoft",kmtoft);
	ee . set_unary_fun("kmtoyd",kmtoyd);
	ee . set_unary_fun("kmtomile",kmtomile);
	ee . set_unary_fun("kmtomm",kmtomm);
	ee . set_unary_fun("kmtocm",kmtocm);
	ee . set_unary_fun("kmtom",kmtom);
	ee . set_unary_fun("lbtooz",lbtooz);
	ee . set_unary_fun("lbtog",lbtog);
	ee . set_unary_fun("lbtokg",lbtokg);
	ee . set_unary_fun("oztolb",oztolb);
	ee . set_unary_fun("oztog",oztolb);
	ee . set_unary_fun("oztokg",oztolb);
	ee . set_unary_fun("gtolb",gtolb);
	ee . set_unary_fun("gtooz",gtooz);
	ee . set_unary_fun("gtokg",gtokg);
	ee . set_unary_fun("kgtolb",kgtolb);
	ee . set_unary_fun("kgtooz",kgtooz);
	ee . set_unary_fun("kgtog",kgtog);
	ee . set_unary_fun("dtomin",dtomin);
	ee . set_unary_fun("dtos",dtos);
	ee . set_unary_fun("mintod",mintod);
	ee . set_unary_fun("mintos",mintos);
	ee . set_unary_fun("stod",stod);
	ee . set_unary_fun("stomin",stomin);
	ee . set_unary_fun("mphtomps",mphtomps);
	ee . set_unary_fun("mphtofph",mphtofph);
	ee . set_unary_fun("mphtokph",mphtokph);
	ee . set_unary_fun("mphtoknot",mphtoknot);
	ee . set_unary_fun("mpstomph",mpstomph);
	ee . set_unary_fun("mpstofph",mpstofph);
	ee . set_unary_fun("mpstokph",mpstokph);
	ee . set_unary_fun("mpstoknot",mpstoknot);
	ee . set_unary_fun("fphtomph",fphtomph);
	ee . set_unary_fun("fphtomps",fphtomps);
	ee . set_unary_fun("fphtokph",fphtokph);
	ee . set_unary_fun("fphtoknot",fphtoknot);
	ee . set_unary_fun("kphtomph",kphtomph);
	ee . set_unary_fun("kphtomps",kphtomps);
	ee . set_unary_fun("kphtofph",kphtofph);
	ee . set_unary_fun("kphtoknot",kphtoknot);
	ee . set_unary_fun("knottomph",knottokph);
	ee . set_unary_fun("knottomps",knottomps);
	ee . set_unary_fun("knottofph",knottofph);
	ee . set_unary_fun("knottokph",knottokph);
	ee . set_unary_fun("ctof",ctof);
	ee . set_unary_fun("ctok",ctok);
	ee . set_unary_fun("ftoc",ftoc);
	ee . set_unary_fun("ftok",ftok);
	ee . set_unary_fun("ktoc",ktoc);
	ee . set_unary_fun("ktof",ktof);
}

string getFunction(int menu, int cursor1, int cursor2) {
	string function;
	if (menu == 1) {
		if (cursor1 == 1) function = "in";
		if (cursor1 == 2) function = "ft";
		if (cursor1 == 3) function = "yd";
		if (cursor1 == 4) function = "mile";
		if (cursor1 == 5) function = "mm";
		if (cursor1 == 6) function = "cm";
		if (cursor1 == 7) function = "m";
		if (cursor1 == 8) function = "km";
		function = function + "to";
		if (cursor2 == 1) function = function + "in()";
		if (cursor2 == 2) function = function + "ft()";
		if (cursor2 == 3) function = function + "yd()";
		if (cursor2 == 4) function = function + "mile()";
		if (cursor2 == 5) function = function + "mm()";
		if (cursor2 == 6) function = function + "cm()";
		if (cursor2 == 7) function = function + "m()";
		if (cursor2 == 8) function = function + "km()";
		return function;
	}
	if (menu == 2) {
		if (cursor1 == 1) function = "lb";
		if (cursor1 == 2) function = "oz";
		if (cursor1 == 3) function = "g";
		if (cursor1 == 4) function = "kg";
		function = function + "to";
		if (cursor2 == 1) function = function + "lb()";
		if (cursor2 == 2) function = function + "oz()";
		if (cursor2 == 3) function = function + "g()";
		if (cursor2 == 4) function = function + "kg()";
		return function;
	}
	if (menu == 3) {
		if (cursor1 == 1) function = "d";
		if (cursor1 == 2) function = "min";
		if (cursor1 == 3) function = "s";
		function = function + "to";
		if (cursor2 == 1) function = function + "d()";
		if (cursor2 == 2) function = function + "min()";
		if (cursor2 == 3) function = function + "s()";
		return function;
	}
	if (menu == 4) {
		if (cursor1 == 1) function = "mph";
		if (cursor1 == 2) function = "mps";
		if (cursor1 == 3) function = "fph";
		if (cursor1 == 4) function = "kph";
		if (cursor1 == 5) function = "knot";
		function = function + "to";
		if (cursor2 == 1) function = function + "mph()";
		if (cursor2 == 2) function = function + "mps()";
		if (cursor2 == 3) function = function + "fph()";
		if (cursor2 == 4) function = function + "kph()";
		if (cursor2 == 5) function = function + "knot()";
		return function;
	}
	if (menu == 5) {
		if (cursor1 == 1) function = "c";
		if (cursor1 == 2) function = "f";
		if (cursor1 == 3) function = "k";
		function = function + "to";
		if (cursor2 == 1) function = function + "c()";
		if (cursor2 == 2) function = function + "f()";
		if (cursor2 == 3) function = function + "k()";
		return function;
	}	
}
