#include "subprogram.h"

extern SDL_Color sdlwhite, sdlblack, sdlblue;
extern Uint32 blue, grey, lightgrey, darkgrey;
extern SDL_Surface *im_screen, *img_check, *img_music, *img_view, *img_test;
extern TTF_Font *font, *systemfont;
extern int nCol, nLine, menu, menucursor, mode, menumode, lastmode, wait, directorymode, audindex;
extern bool isplaying, ispaused, shuffled, plplay, padrelease, transition, bmUpdate, bAlarm, bview, btest;
extern vector <string> playlist, diraudio;
extern string audiodir;
extern SceCtrlData pad;

extern codecStubs *decoder;

int plselect, plcursor, plscroll, plmaxlines = 10;

void getPlaylistInput(void)
{
	if (pad.Buttons & PSP_CTRL_UP) {
		if ((plselect + plscroll == 0) && plselect > 0) plscroll++;
		plselect--;
		if (plselect < 0) plselect = 0;
		plcursor--;
		if (plcursor < 0) plcursor = 0;

		wait = 100;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_DOWN) {
		if ((plselect + plscroll == plmaxlines-1) && plselect < playlist.size()-1) plscroll--;
		plselect++;
		if (plselect == playlist.size()) plselect = playlist.size()-1;
		plcursor++;
		if (plcursor == plmaxlines) plcursor = plmaxlines-1;
		
		if (plcursor == playlist.size()) plcursor = playlist.size()-1;

		wait = 100;
		bmUpdate = true;
	}
	if (pad.Buttons & PSP_CTRL_RTRIGGER && padrelease)
	{
		directorymode = 2;
		listDirectory(audiodir);
		menumode = 5;
		plcursor = 0;
		plselect = 0;
		plscroll = 0;
		padrelease = false;
		bmUpdate = true;
	}
	if (pad.Buttons & PSP_CTRL_SQUARE)
	{
		playlist.clear();
		plselect = 0;
		plcursor = 0;
		plscroll = 0;
		bmUpdate = true;
	}
	if (pad.Buttons & PSP_CTRL_TRIANGLE && padrelease && playlist.size() > 0)
	{
		playlist.erase(playlist.begin() + plselect);
		if (plselect > playlist.size() - 1) 
		{
			if (plselect == plcursor && plscroll == 0) plcursor--;
			plselect--;
			if (plscroll < 0) plscroll++;				
		}
		
		if (playlist.size() == 0 && isplaying && plplay)
		{				
			decoder->stop();
			decoder->end();	
			isplaying = false;
			ispaused = false;
			plplay = false;
		}
		padrelease = false;
		bmUpdate = true;
		wait = 120;
	}		
	if (pad.Buttons & PSP_CTRL_CROSS && playlist.size() > 0 && padrelease)
	{
		if (bview) {
			SDL_FreeSurface(img_view);
			bview = false;
		}
		if (mode != 4 && mode != 7) {
			if (btest) SDL_FreeSurface(img_test);
			btest = false;
		}
			
		if (isplaying) {
			decoder->stop();
			decoder->end();
		}
		string readfile = playlist[plselect];
		load_play(readfile.c_str());
		isplaying = true;
		ispaused = false;
		bAlarm = false;
		plplay = true;
		audindex = plselect;
		menumode = 0;
		wait = 200;
		padrelease = false;
		transition = true;
		bmUpdate = true;		
	}
}

void displayPlaylist(void)
{
	int count, findlast;
	string textscroll;
	char sizestring[50];
	
	drawMenuFrame(im_screen);
	if (menumode == PLAYLIST) {
		drawText(systemfont,im_screen,30,161,"Clear All:         Remove:           Select:",sdlblack);
		drawText(systemfont,im_screen,30,161,"           Square          Triangle          Cross",sdlblue);
	}	
	drawFillRect(im_screen,26,28,428,10,lightgrey);
	drawHline(im_screen,26,37,428,darkgrey);
	
	drawText(font,im_screen,212,17,"Playlist", sdlblack);
	for (count = 0; count < playlist.size(); count++) {
		findlast = playlist[count].find_last_of("/");
		if (findlast != string::npos)
		{
			textscroll = playlist[count].substr(findlast+1);			
		}
		if (textscroll.size() > 58) textscroll = textscroll.substr(0,58);
		
		if (plselect == count) drawFillRect(im_screen,34,40+plcursor*nLine - 1, 15+textscroll.size() * nCol, nLine, grey);
		if ((plscroll*nLine + count*nLine) < 120 && (plscroll*nLine + count*nLine) >= 0) 
		{
			if (is_audio(playlist[count])) {
				blit(im_screen,33,40+plscroll*nLine+count*nLine,img_music);
				drawText(font,im_screen,48,40+plscroll*nLine+count*nLine, textscroll, sdlblack);
			}
		}
	}
}

void getMusicMenuInput(void)
{
	string readfile;
	
	if (padrelease) {
		if (pad.Buttons & PSP_CTRL_RIGHT) {
			if (menumode >= CLOCK && menumode <= TIMER) menu = 8;
			else if (mode == IMAGE) menu = 5;
			else if (mode == CALENDAR) menu = 7;					
			else if (mode == CALCULATOR) {
					menu = 6;
					initCalculatorMenu();
				}					
			else menu = 1;
			menucursor = 1;
			wait = 100;
			padrelease = false; 
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_LEFT) {
			lastmode = mode;
			if (mode > 0 && mode < 4) {
				mode = 2;
			}
			menu = 3;
			menucursor = 1;
			wait = 100;
			padrelease = false;
			bmUpdate = true;
		}
	}

	
	if (pad.Buttons & PSP_CTRL_UP) {
		if (menucursor == 1) menucursor = 7;
		else menucursor--;
		wait = 100;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_DOWN) {
		if (menucursor == 7) menucursor = 1;
		else menucursor++;
		wait = 100;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_CROSS) {
		if (menucursor == 1) {
			directorymode = 2;
			listDirectory(audiodir);
			menumode = DIRECTORY;
			plcursor = 0;
			plselect = 0;
			plscroll = 0;
			padrelease = false;
			menu = 0;
		}
		if (menucursor == 2) {
			menumode = PLAYLIST;
			plcursor = 0;
			plselect = 0;
			plscroll = 0;
			padrelease = false;					
			menu = 0;
		}				
		if (menucursor == 3) {
			if (isplaying) {
				decoder->pause();
				ispaused = !ispaused;
			}
			menu = 0;
		}
		if (menucursor == 4) {
			if (isplaying) {
				decoder->stop();
				decoder->end();
				isplaying = false;
				ispaused = false;
				bAlarm = false;
			}
			menu = 0;
		}
		if (menucursor == 5) {
			shuffled = !shuffled;
			if (shuffled) random_shuffle(diraudio.begin(),diraudio.end());
			else sort(diraudio.begin(),diraudio.end());

			if (shuffled) random_shuffle(playlist.begin(),playlist.end());
			else sort(playlist.begin(),playlist.end());
			menu = 0;
		}
		if (menucursor == 6 && !bAlarm) {					
			if (isplaying) {
			if (!plplay)
				{
					if (audindex == diraudio.size()-1) audindex = 0;
					else audindex++;
				}
				
				if (plplay)
				{
					if (audindex == playlist.size()-1) audindex = 0;
					else audindex++;
				}						
				decoder->stop();
				decoder->end();
				if (!plplay) readfile = diraudio[audindex];
				else readfile = playlist[audindex];
				
				load_play(readfile.c_str());
			}
			menu = 0;
		}
		if (menucursor == 7 && !bAlarm) {				
			if (isplaying) {
				if (!plplay)
				{
					if (audindex == 0) audindex = diraudio.size()-1;
					else audindex--;
				}
				if (plplay)
				{
					if (audindex == 0) audindex = playlist.size()-1;
					else audindex--;
				}						
				decoder->stop();
				decoder->end();
				if (!plplay) readfile = diraudio[audindex];
				else readfile = playlist[audindex];
				
				load_play(readfile.c_str());
			}
			menu = 0;
		}
		bmUpdate = true;
		transition = true;
	}
}

void displayMusicMenu(void)
{
	int menupos;
	
	if (mode > 0 && mode < 4 && menumode != CLOCK) menupos = 160;
	if (mode >= 4 || mode == 0 || menumode == CLOCK) menupos = 110;
	drawText(font,im_screen,menupos,0, "Music", sdlwhite);

	drawDropmenu(im_screen, menupos, 11, 13, 7);
	
	drawFillRect(im_screen,menupos+6,menucursor*nLine+4, 4*nCol+nCol*13-8, nLine, blue);
	
	if (menucursor == 1) {
		drawTextShadowed(font,im_screen,menupos+20,nLine+4, "Open", sdlwhite);
	}
	else {
		drawText(font,im_screen,menupos+20,nLine+4, "Open", sdlblack);
	}

	if (menucursor == 2) {
		drawTextShadowed(font,im_screen,menupos+20,2*nLine+4, "Playlist", sdlwhite);
	}
	else {
		drawText(font,im_screen,menupos+20,2*nLine+4, "Playlist", sdlblack);
	}		
		
	if (menucursor == 3) {
		drawTextShadowed(font,im_screen,menupos+20,3*nLine+4, "Pause", sdlwhite);
		if (ispaused) blit(im_screen,menupos+4,3*nLine+6,img_check);
	}
	else {
		drawText(font,im_screen,menupos+20,3*nLine+4, "Pause", sdlblack);
		if (ispaused) blit(im_screen,menupos+4,3*nLine+6,img_check);
	}
	
	if (menucursor == 4) drawTextShadowed(font,im_screen,menupos+20,4*nLine+4, "Stop", sdlwhite);
	else drawText(font,im_screen,menupos+20,4*nLine+4, "Stop", sdlblack);
	
	if (menucursor == 5) {
		drawTextShadowed(font,im_screen,menupos+20,5*nLine+4, "Shuffled", sdlwhite);
		if (shuffled) blit(im_screen,menupos+4,5*nLine+6,img_check);
	}
	else {
		drawText(font,im_screen,menupos+20,5*nLine+4, "Shuffled", sdlblack);
		if (shuffled) blit(im_screen,menupos+4,5*nLine+6,img_check);
	}
	if (menucursor == 6) drawTextShadowed(font,im_screen,menupos+20,6*nLine+4, "Play Next", sdlwhite);
	else drawText(font,im_screen,menupos+20,6*nLine+4, "Play Next", sdlblack);
	
	if (menucursor == 7) drawTextShadowed(font,im_screen,menupos+20,7*nLine+4, "Play Previous", sdlwhite);
	else drawText(font,im_screen,menupos+20,7*nLine+4, "Play Previous", sdlblack);
}

void playNextMusic(void)
{
	string readfile;
	
	if (!plplay && !bAlarm && isplaying && decoder->eos != 0) {
		if (decoder->eos() == 1) {	// End of file, advance in playlist
			if (audindex == diraudio.size()-1) audindex = 0;
			else audindex++;
			decoder->stop();
			decoder->end();
			readfile = diraudio[audindex];
			load_play(readfile.c_str());			
		}
	}
	
	if (plplay && !bAlarm && isplaying && decoder->eos != 0) {
		if (decoder->eos() == 1) {	// End of file, advance in playlist
			if (audindex == playlist.size()-1) audindex = 0;
			else audindex++;
			decoder->stop();
			decoder->end();
			readfile = playlist[audindex];
			load_play(readfile.c_str());			
		}
	}
}
