 /***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "subprogram.h"
#include "psp_irkeyb.h"

SDL_Surface *img_text, *img_background, *img_arrow, *img_arrows, *img_dirbuttons, *img_editbuttons, *img_check, *img_doc, *img_dot, *img_folder, *img_music, *img_pic, *img_space, *im_screen;
SDL_Surface *img_rckeys, *img_lckeys, *img_lcskeys, *img_rcskeys, *img_lkeys, *img_rkeys, *img_lskeys, *img_rskeys, *img_calckeys;
SDL_Surface *img_textbackground, *img_menubar, *tmp, *img_view, *img_test, *screen;
SDL_Color sdlwhite = { 0xFF, 0xFF, 0xFF, 0 };
SDL_Color sdlblack = { 0x00, 0x00, 0x00, 0 };
SDL_Color sdlgrey = { 0xC8, 0xC8, 0xC8, 0 };
SDL_Color sdldarkgrey = { 0x7D, 0x7D, 0x7D, 0 };
SDL_Color sdlred = { 0xFF, 0x00, 0x00, 0 };
SDL_Color sdlgreen = { 0x00, 0xFF, 0x00, 0 };
SDL_Color sdlblue = { 0x00, 0x00, 0xFF, 0 };
SDL_Color forecol, fgcol, bgcol;
Uint32 backcol, white, black, grey, lightgrey, darkgrey, red, green, blue, cursorcol;
SDL_Rect dest;
TTF_Font *font, *drawfont, *drawfont10, *drawfont12, *drawfont14, *drawfont16, *drawfont20, *drawfont50, *systemfont;
int ndCol = 7, ndLine = 12, nFontsize = 12, minlines = 14, maxlines = 21; 

int colcursor = 1;

codecStubs stubs[100];
int codecnum=0;
char *audiofile;
codecStubs *decoder;
int codec;

string readfile, currentdir = "ms0:";

vector <Dir> dir;
vector <string> dirimage;
vector <string> diraudio, playlist;

bool bUpdate = false, bmUpdate = false, isplaying = false, ispaused = false, shuffled = false, bAlarm = false;
bool transition = false, padrelease, usb = true, bEndprogram;
bool bview = false, btest = false;

int wait, nMaxchar = 66, nKeyset = 2, nCol = 7, nLine = 12, mode = 0, menu = 0, menucursor, dirselect = 0, lastmode = 1;
int waitanalog = 120, waitdigital = 100, waitpress = 200;
SceCtrlData pad;
SceCtrlLatch latch;
int blx,bly,blh;
int lx, ly, rx, ry;

int nMaxinput = 36, menumode = 0;
int dircursor = 0, dirscroll = 0, dirmaxlines = 10, directorymode = 1;	
string photodir = "ms0:/psp/photo";

string audiodir = "ms0:/psp/music", audiopath = "ms0:/psp/music";
int audindex = 0;


ofstream settingsfile;
string upcurrentdir = "", filedir = "ms0:";

bool plplay = false;


extern "C" int SDL_main( int argc, char *argv[] );

int 
SDL_main(int argc, char *argv[])
{
	int count, retval, blink = 0;
	char sizestring[255];
	u32 ticks, endticks, readticks;
	
	int ax = 1, ay = 1;
	
	int inputcursor = 0;
	
	int findlast;
	
	string oldfile, renamefile, deletefile;
	string textscroll;
	string readkey;
	int menupos = 10;

	bool blUpdate = false;
		
	time_t tTime;
	struct tm * tmTime;
	
	int month,year;
	
	
	
	setfunctions();
	
	pspAudioInit();

#ifdef KERNEL	
	loadUsbDrivers();
	if (usb) retval = sceUsbActivate(0x1c8);
#endif /*KERNEL*/	
	int stubnum = 0;
	CODEC_INITSTUBS codecnum = stubnum;	

	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
				
	/* Initialize the TTF library */
	if ( TTF_Init() < 0 ) {
		fprintf(stderr, "Couldn't initialize TTF: %s\n",SDL_GetError());
		return(2);
	}
	atexit(TTF_Quit);	

	/* Initialize the SDL library */
	if ( SDL_Init(SDL_INIT_TIMER|SDL_INIT_VIDEO) < 0 ) {
		fprintf(stderr, "Couldn't initialize SDL: %s\n",SDL_GetError());
		return(255);
	}
	atexit(SDL_Quit);
	
	screen = SDL_SetVideoMode(480, 272, 32, SDL_FULLSCREEN | SDL_SWSURFACE | SDL_DOUBLEBUF);	
	loadSettings();
	if(load_gfx()){
		fprintf(stderr, "Error: %s\n", SDL_GetError());
		exit(1);	
	}
	im_screen = SDL_DisplayFormat(screen);
	set_colors(screen->format);
	
	sge_ClearSurface(screen, 0xFFFFFFFF);
	padrelease = true;
	readticks = SDL_GetTicks();
	
	initNotepad();
	initTimezone();
	update();
	
	
	while(1) {
		
		if (!bAlarm)
		{
			checkClock();
		}
		
		ticks = SDL_GetTicks();
				
		if (ticks - readticks >= wait) 
		{	
			sceCtrlReadBufferPositive(&pad, 1);
# ifdef USE_PSP_IRKEYB
      psp_irkeyb_set_psp_key(&pad);
# endif
			sceCtrlReadLatch(&latch);
			if (latch.uiRelease == -1) 
			{
				padrelease = true;
				transition = false;
			}
			readticks = ticks;
			wait = 1;
		}
		else 
		{
			pad.Buttons = 0;
			pad.Lx = 127;
			pad.Ly = 127;
		}
		
		if (ticks - endticks >= 1000 && (menumode == CLOCK || menumode == WORLDCLOCK))
		{
			endticks = ticks;
			bmUpdate = true;
		}
		
		if (ticks - endticks >= 100 && swStart())
		{
			endticks = ticks;
			if (menumode == STOPWATCH) bmUpdate = true;
			updateStopwatch();
		}

		if (ticks - endticks >= 100 && tStart())
		{
			endticks = ticks;
			if (menumode == TIMER) bmUpdate = true;
			updateTimer();
		}			
		
		blink++;

		if (blink == 60 || bmUpdate || bUpdate) blink = 0;
		if (blink == 0) {
			blUpdate = true;
			cursorcol = blue;
		}
		if (blink == 30) {
			blUpdate = true;
			if (mode > 0 && mode < 4 && menumode == 0) cursorcol = backcol;
			else cursorcol = white;
		}		
		
		if (padrelease) 
		{
			if (pad.Buttons & PSP_CTRL_SELECT) 
			{
				lastmode = mode;				
				if (menumode > 3) mode = lastmode;
				else if (menumode > 0 && menumode < 4) 
				{
					if (menumode == 2 && getAddressBookSize() == 0) mode = 0;
					else 
					{					
						mode = 5;
						initAddressBook();
					}
				}
				else if (mode == 1) mode = 2;
				else if (mode == 2 || mode == 3) mode = 1;
				else mode = 0;
				scrollText();
				
				clearMarks();
				update();
				if (menumode >= SETCLOCKMENU && menumode <= TIMER) menumode = CLOCK;
				else menumode = 0;				
				menu = 0;
				wait = 200;
				padrelease = false;
			}
			
			if (pad.Buttons & PSP_CTRL_START) 
			{				
				if (menumode == 7) {
					menumode = 6;
				}
				else if (menumode == 6) 
				{
					directorymode = 1;
					listDirectory(filedir);
					dircursor = 0;
					dirselect = 0;
					dirscroll = 0;
					menumode = 7;
				}
				else if (menu > 0) 
				{
						menu = 0;
				}
				else 
				{
					lastmode = mode;
					menucursor = 1;
					if (menumode >= CLOCK && menumode <= TIMER) menu = 8;
					else if (mode == KEYBOARD) menu = 1;
					else if (mode == EDIT) menu = 2;
					else if (mode == FULLSCREEN) menu = 3;
					else if (mode == IMAGE) menu = 5;
					else if (mode == CALCULATOR) 
					{
								menu = 6;
								initCalculatorMenu();
					}
					else if (mode == CALENDAR) menu = 7;
					else menu = 1;
				}
				update();
				wait = 200;
				padrelease = false;
			}

      //LUDO: toggle to edit mode when arrows are pressed
      if (mode == KEYBOARD) {
        if (pad.Buttons & (PSP_CTRL_LEFT|PSP_CTRL_RIGHT|PSP_CTRL_UP|PSP_CTRL_DOWN)) {
          mode = EDIT;
        }
      }
		}		
	
		if (menu == 0) 
		{
			if (menumode == 0) 
			{			
				if (mode == FRONTEND) {
					getFrontendInput();
				}
				if (mode == KEYBOARD) 
				{
					getKeyboardInput();
				}
				if (mode == EDIT) 
				{
					getEditInput();
				}
				
				if (mode == FULLSCREEN) 
				{
					getFullscreenInput();
				}
				
				if (mode >= KEYBOARD && mode <= FULLSCREEN)
				{
					getNotepadInput();
				}
			
				if (mode == IMAGE) {
					getImageViewerInput();
				}
				
				if (mode == ADDRESSBOOK) {
					getAddressBookInput();
				}
				
				if (mode == CALCULATOR) {
					getCalculatorInput();		
				}
				
				if (mode == CALENDAR) {
					getCalendarInput();
				}
	
			} // end mode
	
			if (mode == ADDRESSBOOK) {
				getAddressBookMenuInput();
			}
			
			if (mode == CALENDAR) {
				getCalendarDayInput();
				if (menumode == GOTOMONTH)
				{
					getGotoMonthInput();
				}
				if (menumode == WEEKEVENTS)
				{
					getWeekEventsInput();
				}
				if (menumode == MONTHEVENTS)
				{
					getMonthEventsInput();
				}				
			}


	if (menumode == DIRECTORY || menumode == SELECTDIR) {
	
		if (pad.Buttons & PSP_CTRL_UP) {
			if ((dirselect + dirscroll == 0) && dirselect > 0) dirscroll++;
			dirselect--;
			if (dirselect < 0) dirselect = 0;
			dircursor--;
			if (dircursor < 0) dircursor = 0;
	
			wait = 100;
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_DOWN) {
			if ((dirselect + dirscroll == dirmaxlines-1) && dirselect < dir.size()-1) dirscroll--;
			dirselect++;
			if (dirselect == dir.size()) dirselect = dir.size()-1;
			dircursor++;
			if (dircursor == dirmaxlines) dircursor = dirmaxlines-1;
			
			if (dircursor == dir.size()) dircursor = dir.size()-1;
	
			wait = 100;
			bmUpdate = true;
		}
	}

	if (menumode == DIRECTORY) {

		if (padrelease && !transition) {
			if (pad.Buttons & PSP_CTRL_SQUARE) {
				if (dir[dirselect].name != "." || dir[dirselect].name != "..") {
					oldfile = dir[dirselect].name;
					renamefile = "";
					inputcursor = 0;
					menumode = 13;
					bmUpdate = true;
				}
			}
			if (pad.Buttons & PSP_CTRL_TRIANGLE) {
				if (dir[dirselect].name != "." || dir[dirselect].name != "..") {
					deletefile = dir[dirselect].name;					
					menumode = 14;
					bmUpdate = true;
				}
			}
			if (pad.Buttons & PSP_CTRL_CIRCLE && padrelease) 
			{
				if (dir[dirselect].isDir && dir[dirselect].name != "..")
				{
					listAudioDirectory(currentdir + "/" + dir[dirselect].name, 1);
				}
				else if (is_audio(dir[dirselect].name)) 
				{
					playlist.push_back(currentdir + "/" + dir[dirselect].name);
					if (shuffled) random_shuffle(playlist.begin(), playlist.end());
					else sort(playlist.begin(), playlist.end());					
				}
				padrelease = false;
				wait = 120;
			}
			if (pad.Buttons & PSP_CTRL_RTRIGGER && padrelease)
			{
				menumode = PLAYLIST;
				dircursor = 0;
				dirselect = 0;
				dirscroll = 0;
				padrelease = false;
				bmUpdate = true;
				menu = 0;			
			}
			if (pad.Buttons & PSP_CTRL_CROSS) {
				if (directorymode == 1) currentdir = filedir;
				if (directorymode == 2) currentdir = audiodir;
				if (directorymode == 3) currentdir = photodir;
				if (dir[dirselect].isDir) {
					findlast = currentdir.find_last_of("/");
					if (findlast != string::npos) upcurrentdir = currentdir.substr(0,findlast);
					else upcurrentdir = "ms0:";
					
					if (dir[dirselect].name == "..") currentdir = upcurrentdir;
					else if (dir[dirselect].name != ".") currentdir = currentdir + "/" + dir[dirselect].name;
					
					listDirectory(currentdir);
					dircursor = 0;
					dirselect = 0;
					dirscroll = 0;
					if (directorymode == 1) filedir = currentdir;
					if (directorymode == 2) audiodir = currentdir;
					if (directorymode == 3) photodir = currentdir;					
				}
				else {		
					readfile = currentdir + "/" + dir[dirselect].name;
					
					if (is_image(dir[dirselect].name)) {
						/*
						if (isplaying) {
							isplaying = false;
							decoder->stop();
							decoder->end();
						}
						*/
						initNotepad();
						
						mode = IMAGE;
						menumode = 0;
						lastmode = 4;
						initImageViewer(currentdir,dir[dirselect].name);
					}
					else if (is_audio(dir[dirselect].name)) {
						/*
						if (mode == 4) {
							SDL_FreeSurface(img_test);
							SDL_FreeSurface(img_view);
							mode = 1;
						}
						*/
						//if (img_test) SDL_FreeSurface(img_test);
						
						if (bview) {
							SDL_FreeSurface(img_view);
							bview = false;
						}
						if (mode != 4 && mode != 7) {
							if (btest) SDL_FreeSurface(img_test);
							btest = false;
						}
							
						if (isplaying) {
							decoder->stop();
							decoder->end();
						}
						load_play(readfile.c_str());
						isplaying = true;
						ispaused = false;
						bAlarm = false;
						plplay = false;
						audindex = 0;
						audiopath = currentdir;
						listAudioDirectory(currentdir, 0);
						while ((currentdir + "/" + dir[dirselect].name) != diraudio[audindex]) audindex++;
						menumode = 0;
					}					
					else if (is_exec(dir[dirselect].name)) {
#ifdef KERNEL					
						SetupExecute(readfile);
#endif /*KERNEL*/					
					}
					else {
						loadText();
						mode = FULLSCREEN;
						menumode = 0;
					}
				}
				wait = 200;
				padrelease = false;
				transition = true;
				bmUpdate = true;
			}
			
		}
	}
	
	if (menumode == PLAYLIST)
	{
		getPlaylistInput();		
	}
	
	getNotepadMenuInput();

	if (menumode == RENAME) {
		if (padLeft()) {
			if (inputcursor > 0) {
				inputcursor--;
				wait = 120;
				bmUpdate = true;
			}
		}
		
		if (padRight()) {
			if (inputcursor < renamefile.size()) {
				inputcursor++;
				wait = 120;
				bmUpdate = true;
			}
		}	
		readKeyboard();
		readkey = readKey();
# ifdef USE_PSP_IRKEYB
  if (readkey == "ed") {
    /*LUDO: TO_BE_DONE */
    readkey ="";
  }
# endif
		if (readkey != "") {
			if (readkey == "bs") {
				if (inputcursor > 0 && renamefile.size() > 0) {
					renamefile.erase(inputcursor-1,1);
					inputcursor--;
				}
			}
			else if (readkey == "en") {
				if (renamefile.size() > 0) {
					if (directorymode == 1) currentdir = filedir;
					if (directorymode == 2) currentdir = audiodir;
					if (directorymode == 3) currentdir = photodir;					
					string savefile = currentdir + "/" + renamefile;
					readfile = currentdir + "/" + oldfile;
					sceIoRename(readfile.c_str(),savefile.c_str());
					listDirectory(currentdir);
					menumode = 5;
					wait = 100;
					dircursor = 0;
					dirselect = 0;
					dirscroll = 0;
					inputcursor = 0;
					if (directorymode == 1) filedir = currentdir;
					if (directorymode == 2) audiodir = currentdir;
					if (directorymode == 3) photodir = currentdir;						
				}
			}
			else if (renamefile.size() < 256) {
					renamefile.insert(inputcursor,readkey);
					inputcursor++;
				}
			
			bmUpdate = true;
			transition = true;
		}
	}
	
	if (menumode == DELETE) {
		if (pad.Buttons & PSP_CTRL_CROSS) {
			if (directorymode == 1) currentdir = filedir;
			if (directorymode == 2) currentdir = audiodir;
			if (directorymode == 3) currentdir = photodir;			
			readfile = currentdir + "/" + deletefile;
			if (dir[dirselect].isDir) sceIoRmdir(readfile.c_str());
			else sceIoRemove(readfile.c_str());
			listDirectory(currentdir);
			dircursor = 0;
			dirselect = 0;
			dirscroll = 0;
			menumode = 5;
			padrelease = false;
			bmUpdate = true;
			transition = true;
			if (directorymode == 1) filedir = currentdir;
			if (directorymode == 2) audiodir = currentdir;
			if (directorymode == 3) photodir = currentdir;			
		}
	}
	if (menumode == KEYBOARDSETTINGS) {
		if (pad.Buttons & PSP_CTRL_UP) {
			if (colcursor == 0) colcursor = 3;
			else colcursor--;
			
			wait = 100;
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_DOWN) {
			if (colcursor == 3) colcursor = 0;
			else colcursor++;
			
			wait = 100;
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_LEFT) {
			if (colcursor == 0) {
				if (nKeyset != 1) nKeyset--;
			}				
			if (colcursor == 1) {
				if (waitdigital != 0) waitdigital--;
			}
			if (colcursor == 2) {
				if (waitanalog != 0) waitanalog--;
			}
			if (colcursor == 3) {
				if (waitpress != 0) waitpress--;
			}
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_RIGHT) {
			if (colcursor == 0) {
				if (nKeyset != 4) nKeyset++;
			}
			if (colcursor == 1) {
				if (waitdigital != 255) waitdigital++;
			}
			if (colcursor == 2) {
				if (waitanalog != 255) waitanalog++;
			}
			if (colcursor == 3) {
				if (waitpress != 255) waitpress++;
			}
			bmUpdate = true;
		}

		if (pad.Buttons & PSP_CTRL_CROSS && !transition) {
			lx = 0;
			rx = 0;
			menumode = 0;
			update();			
			wait = 200;
			saveSettings();
			transition = true;
		}
	}
	
	if (menumode == THEME)
	{
		getThemeInput();
	}
	
	if (menumode == CLOCK)
	{
		getClockInput();
	}
	
	if (menumode == SETCLOCKMENU)
	{
		getSetClockInput();
	}
	
	if (menumode == WORLDCLOCK)
	{
		getWorldClockInput();
	}
	
	if (menumode == STOPWATCH)
	{
		getStopwatchInput();
	}
	
	if (menumode == TIMER)
	{
		getTimerInput();
	}
	 
	
	} // end menu == 0;
	
		getFrontendDropMenuInput();
	
		if (menu == 2) {
			getEditMenuInput();
		}
		if (menu == 4) {
			getMusicMenuInput();
		}
		
		if (menu == 5) {
			getImageViewerMenuInput();
		}
		
		if (menu == 6) {
			getCalculatorMenuInput();			
		}
		
		if (menu == 7) 
		{
			getCalendarMenuInput();
		}
		
		if (menu == 8)
		{
			getClockMenuInput();
		}	
				
		if (mode >= KEYBOARD && mode <= FULLSCREEN)
		{
			drawNotepadText();
		}
	


if (bmUpdate) {	
	blx = 0;

		if (mode == FRONTEND) {
			displayFrontend();		
		}
		
		if (mode >= KEYBOARD && mode <= FULLSCREEN)
		{
			displayNotepad();
		}


	if (mode == IMAGE) {
		if (menumode > 0 || menu > 0) {
			displayImageViewer(im_screen);
		}
		else displayImageViewer(screen);
	}
	
	if (mode == ADDRESSBOOK) {
		displayAddressBook();
	}

	if (mode == CALCULATOR) {
		displayCalculator();
	}
	
	if (mode == CALENDAR) {
		displayCalendar(im_screen);
		displayCalendarDay();
		if (menumode == GOTOMONTH)
		{
			displayGotoMonth();
		}
		if (menumode == WEEKEVENTS)
		{
			displayWeekEvents();
		}
		if (menumode == MONTHEVENTS)
		{
			displayMonthEvents();
		}		
	}
	
	if (menumode == CLOCK) {
		displayClock();
	}	
		
	if (menumode == 5 || menumode == 7) {
		if (directorymode == 1) currentdir = filedir;
		if (directorymode == 2) currentdir = audiodir;
		if (directorymode == 3) currentdir = photodir;
		
		drawMenuFrame(im_screen);

		drawFillRect(im_screen,26,28,428,10,lightgrey);
		drawHline(im_screen,26,37,428,darkgrey);
		
		if (currentdir.size() > 59) textscroll = currentdir.substr(0,59);
		else textscroll = currentdir;
		drawText(font,im_screen,35,27, textscroll, sdlblack);
		drawText(font,im_screen,226,17,"Open", sdlblack);
		for (count = 0; count < dir.size(); count++) {
			if (dir[count].name.size() > 58) textscroll = dir[count].name.substr(0,58);
			else textscroll = dir[count].name;
			
			if (dirselect == count) 
			{
				drawFillRect(im_screen,34,40+dircursor*nLine - 1, 15+textscroll.size() * nCol, nLine, grey);
				if (menumode == 5 && dir[count].name != ".." && (dir[count].isDir || is_audio(dir[count].name))) {
					drawText(systemfont,im_screen,30,161,"Rename:        Delete:          Select:       Add to Playlist:",sdlblack);
					drawText(systemfont,im_screen,30,161,"        Square         Triangle         Cross                  Circle",sdlblue);
				}
				else if (menumode == 5) 
				{
					drawText(systemfont,im_screen,30,161,"Rename:        Delete:          Select:",sdlblack);
					drawText(systemfont,im_screen,30,161,"        Square         Triangle         Cross",sdlblue);
				}	
			}
			if ((dirscroll*nLine + count*nLine) < 120 && (dirscroll*nLine + count*nLine) >= 0) {
				if (dir[count].isDir) 
				{
					blit(im_screen,30,40+dirscroll*nLine+count*nLine,img_folder);
					drawText(font,im_screen,48,40+dirscroll*nLine+count*nLine, textscroll, sdlblue);				
				}
				else if (is_image(dir[count].name)) 
				{
					blit(im_screen,32,40+dirscroll*nLine+count*nLine,img_pic);
					drawText(font,im_screen,48,40+dirscroll*nLine+count*nLine, textscroll, sdlblack);
				}
				else if (is_audio(dir[count].name)) 
				{
					blit(im_screen,33,40+dirscroll*nLine+count*nLine,img_music);
					drawText(font,im_screen,48,40+dirscroll*nLine+count*nLine, textscroll, sdlblack);					
				}
				else 
				{
					blit(im_screen,33,40+dirscroll*nLine+count*nLine,img_doc);
					drawText(font,im_screen,48,40+dirscroll*nLine+count*nLine, textscroll, sdlblack);
				}
			}
		}
	}
	
	displayNotepadMenu();

	if (menumode == 13) {

		drawKeyboard(im_screen);
		drawMenuFrame(im_screen);
		
		drawFillRect(im_screen,176,46,260,16,white);
		drawRect(im_screen,177,47,260,16,black);
		drawRect(im_screen,176,46,260,16,grey);
		drawFillRect(im_screen,176,66,260,16,grey);
		drawRect(im_screen,177,67,260,16,black);
		drawRect(im_screen,176,66,260,16,grey);
		
		drawText(font,im_screen,40, 50, "New Name:",sdlblack);
		drawText(font,im_screen,40, 70, "Old Name:",sdlblack);
		
		if (renamefile.size() > nMaxinput) {
			if (inputcursor < renamefile.size() - nMaxinput) textscroll = renamefile.substr(inputcursor,nMaxinput);
			else textscroll = renamefile.substr(renamefile.size()-nMaxinput);
		}
		else textscroll = renamefile;
		drawText(font,im_screen,180,50, textscroll.c_str(), sdlblack);
		
		if (renamefile.size() <= nMaxinput) blx = 180+inputcursor*nCol;
		else {
			if (inputcursor < renamefile.size() - nMaxinput) blx = 180;
			else blx = 180+(nMaxinput)*nCol-renamefile.size()*nCol+inputcursor*nCol;
		}
		bly = 48;
		blh = nLine;
		
		if (oldfile.size() > nMaxinput) textscroll = oldfile.substr(0,nMaxinput);
		else textscroll = oldfile;
		drawText(font,im_screen,180,70, textscroll.c_str(), sdlblack);
		
		drawText(font,im_screen,40,120, "Press Select to cancel", sdlblue);
		drawText(font,im_screen,40,140, "Press Enter to rename", sdlblue);

		drawText(font,im_screen,211,17,"Rename File", sdlblack);
	}
	
	if (menumode == 14) {
		drawMenuFrame(im_screen);
		
		drawFillRect(im_screen,176,46,260,16,grey);
		drawRect(im_screen,177,47,260,16,black);
		drawRect(im_screen,176,46,260,16,grey);

		drawText(font,im_screen, 40, 50, "Delete File:",sdlblack);
		if (deletefile.size() > nMaxinput) {
			textscroll = deletefile.substr(deletefile.size()-nMaxinput);
		}
		else {
			textscroll = deletefile;
		}
		drawText(font,im_screen,180,50, textscroll.c_str(), sdlblack);
		drawText(font,im_screen,40,120, "Press Select to cancel", sdlblue);
		drawText(font,im_screen,40,140, "Press Cross to delete", sdlblue);
		drawText(font,im_screen,194,17,"OK to delete?", sdlblack);
	}
	
	if (menumode == 18) {
		drawMenuFrame(im_screen);
		if (colcursor == 0) drawTextShadowed(font,im_screen,40,30,"Keyboard:", sdlwhite);
		else drawText(font,im_screen,40,30,"Keyboard:", sdlblack);
		if (nKeyset == 1) drawTextShadowed(font,im_screen,120,30,"Analog", sdlblue);
		else drawText(font,im_screen,120,30,"Analog", sdlblack);
		if (nKeyset == 2) drawTextShadowed(font,im_screen,182,30,"Digital", sdlblue);
		else drawText(font,im_screen,182,30,"Digital", sdlblack);
		if (nKeyset == 3) drawTextShadowed(font,im_screen,251,30,"2-Cursor", sdlblue);
		else drawText(font,im_screen,251,30,"2-Cursor", sdlblack);
		if (nKeyset == 4) drawTextShadowed(font,im_screen,327,30,"P-Sprint", sdlblue);
		else drawText(font,im_screen,327,30,"P-Sprint", sdlblack);		
		if (colcursor == 1) drawTextShadowed(font,im_screen,40, 50, "Digital:", sdlwhite);
		else drawText(font,im_screen,40, 50, "Digital:" ,sdlblack);
		if (colcursor == 2) drawTextShadowed(font,im_screen,40, 70, "Analog:", sdlwhite);
		else drawText(font,im_screen,40, 70, "Analog:" ,sdlblack);
		if (colcursor == 3) drawTextShadowed(font,im_screen,40, 90, "Button:", sdlwhite);
		else drawText(font,im_screen,40, 90, "Button:" ,sdlblack);
		sprintf(sizestring,"%d",waitdigital);
		drawText(font,im_screen,365, 50, sizestring ,sdlblack);
		sprintf(sizestring,"%d",waitanalog);
		drawText(font,im_screen,365, 70, sizestring ,sdlblack);
		sprintf(sizestring,"%d",waitpress);
		drawText(font,im_screen,365, 90, sizestring ,sdlblack);
		
		drawFillRect(im_screen,100,55,255,2,grey);
		drawFillRect(im_screen,100,75,255,2,grey);
		drawFillRect(im_screen,100,95,255,2,grey);
		
		drawFillRect(im_screen,99+waitdigital,53,3,5,darkgrey);
		drawFillRect(im_screen,99+waitanalog,73,3,5,darkgrey);
		drawFillRect(im_screen,99+waitpress,93,3,5,darkgrey);
		

		drawText(font,im_screen,40,120, "Press Select to cancel", sdlblue);
		drawText(font,im_screen,40,140, "Press Cross when done", sdlblue);
		drawText(font,im_screen,180,17,"Keyboard Settings", sdlblack);
	}
	
	if (menumode == THEME)
	{
		displayTheme();
	}
	
	if (menumode == CLOCK)
	{
		displayClock();
	}

	if (menumode == SETCLOCKMENU)
	{
		displaySetClock();
	}
	
	if (menumode == WORLDCLOCK)
	{
		displayWorldClock();
	}
	
	if (menumode == STOPWATCH)
	{
		displayStopwatch();
	}
	
	if (menumode == TIMER)
	{
		displayTimer();
	}
	
	if (menumode == PLAYLIST)
	{
		displayPlaylist();
	}
	
	if (menumode < CLOCK || menumode > TIMER)
	{
		if (menu > 0 && mode >= KEYBOARD && mode <= FULLSCREEN) {
			displayNotepadDropMenu();
		}
	
		if (menu > 0 && mode == IMAGE) {
			displayImageViewerMenu(im_screen);
		}
			
		if (mode == ADDRESSBOOK) {
			displayAddressBookMenu();
		}		
	
		if (mode == CALCULATOR) {
			displayCalculatorMenu();
		}
			
		if (menu > 0 && mode == CALENDAR)
		{
			displayCalendarMenu();
		}
	}
	if (menu > 0 && menumode >= CLOCK && menumode <= TIMER)
	{
		displayClockMenu(im_screen);
	}
	

	displayFrontendDropMenu();
	
	if (menu == 4) {
		displayMusicMenu();
	}

			
} // end bmUpdate;

		playNextMusic();
		
		
		if ((blUpdate || bmUpdate) && mode != IMAGE) {			
			blit(screen,0,0,im_screen);
		}
		
		if ((blUpdate || bmUpdate) && mode == IMAGE) {
			if (menumode > 0 || menu > 0) blit(screen,0,0,im_screen);
		}		
		if ((blUpdate || bUpdate) && blx > 0 && menu == 0) drawVline(screen,blx,bly,blh, cursorcol);

		SDL_Delay(1);
		if (blx == 0) blUpdate = false;

		if ((blUpdate || bmUpdate)) SDL_Flip(screen);
		bUpdate = false;
		bmUpdate = false;
		blUpdate = false;
		
		if (bEndprogram) break;
	}
		
	SDL_FreeSurface(img_text);
	
	pspAudioEnd();

	return 0;
}
