#include "subprogram.h"
#include "psp_irkeyb.h"


static string lkeys[4][9] = { { " ", "`", "1", "2", "3", "4", "5", "6", " " },
          { " ", "     ", "     ", "q", "w", "e", "r", "t", " " },
          { " ", "cl", "cl", "a", "s", "d", "f", "g", " " },
          { " ", "ls", "ls", "z", "x", "c", "v", "b", " " } };
          
static string rkeys[4][16] = { { " ", "7", "8", "9", "0", "-", "=", "bs", "bs", "fact()", "(", ")", "7", "8", "9", "/" },
          { " ", "y", "u", "i", "o", "p", "[", "]", "\\", "sin()", "exp()", "^", "4", "5", "6", "*" },
          { " ", "h", "j", "k", "l", ";", "'", "en", "en", "cos()", "log()", "pi", "1", "2", "3", "-" },
          { " ", "n", "m", ",", ".", "/", "rs", "rs", " ", "tan()", "log10()", "sqrt()", "0", " ", ".", "+" } };
		  
static string loc_keys[4][24] = { { " ", "`", "1", "2", "3", "4", "5", "6", " ", "7", "8", "9", "0", "-", "=", "bs", "bs", "fact()", "(", ")", "7", "8", "9", "/" },
          { " ", "     ", "     ", "q", "w", "e", "r", "t", " ", "y", "u", "i", "o", "p", "[", "]", "\\", "sin()", "exp()", "^", "4", "5", "6", "*" },
          { " ", "cl", "cl", "a", "s", "d", "f", "g", " ", "h", "j", "k", "l", ";", "'", "en", "en", "cos()", "log()", "pi", "1", "2", "3", "-" },
          { " ", "ls", "ls", "z", "x", "c", "v", "b", " ", "n", "m", ",", ".", "/", "rs", "rs", " ", "tan()", "log10()", "sqrt()", "0", " ", ".", "+" } };
          
static string lskeys[4][9] = { { " ", "~", "!", "@", "#", "$", "%", "^", " " },
           { " ", "     ", "     ", "Q", "W", "E", "R", "T", " " },
           { " ", "cl", "cl", "A", "S", "D", "F", "G", " " },
           { " ", "ls", "ls", "Z", "X", "C", "V", "B", " " } };
          
static string rskeys[4][16] = { { " ", "&", "*", "(", ")", "_", "+", "bs", "bs", "fact()", "(", ")", "7", "8", "9", "/" },
           { " ", "Y", "U", "I", "O", "P", "{", "}", "|", "sin()", "exp()", "^", "4", "5", "6", "*" },
           { " ", "H", "J", "K", "L", ":", "\"", "en", "en", "cos()", "log()", "pi", "1", "2", "3", "-" },
           { " ", "N", "M", "<", ">", "?", "rs", "rs", " ", "tan()", "log10()", "sqrt()", "0", " ", ".", "+" } };
		   
static string skeys[4][24] = { { " ", "~", "!", "@", "#", "$", "%", "^", " ", "&", "*", "(", ")", "_", "+", "bs", "bs", "fact()", "(", ")", "7", "8", "9", "/" },
           { " ", "     ", "     ", "Q", "W", "E", "R", "T", " ", "Y", "U", "I", "O", "P", "{", "}", "|", "sin()", "exp()", "^", "4", "5", "6", "*" },
           { " ", "cl", "cl", "A", "S", "D", "F", "G", " ", "H", "J", "K", "L", ":", "\"", "en", "en", "cos()", "log()", "pi", "1", "2", "3", "-" },
           { " ", "ls", "ls", "Z", "X", "C", "V", "B", " ", "N", "M", "<", ">", "?", "rs", "rs", " ", "tan()", "log10()", "sqrt()", "0", " ", ".", "+" } };		   
             
static string lckeys[4][9] = { { " ", "`", "1", "2", "3", "4", "5", "6", " " },
           { " ", "     ", "     ", "Q", "W", "E", "R", "T", " " },
           { " ", "cl", "cl", "A", "S", "D", "F", "G", " " },
           { " ", "ls", "ls", "Z", "X", "C", "V", "B", " " } };
          
static string rckeys[4][16] = { { " ", "7", "8", "9", "0", "-", "=", "bs", "bs", "fact()", "(", ")", "7", "8", "9", "/" },
           { " ", "Y", "U", "I", "O", "P", "[", "]", "\\", "sin()", "exp()", "^", "4", "5", "6", "*" },
           { " ", "H", "J", "K", "L", ";", "'", "en", "en", "cos()", "log()", "pi", "1", "2", "3", "-" },
           { " ", "N", "M", ",", ".", "/", "rs", "rs", " ", "tan()", "log10()", "sqrt()", "0", " ", ".", "+" } } ;
		   
static string ckeys[4][24] = { { " ", "`", "1", "2", "3", "4", "5", "6", " ", "7", "8", "9", "0", "-", "=", "bs", "bs", "fact()", "(", ")", "7", "8", "9", "/" },
           { " ", "     ", "     ", "Q", "W", "E", "R", "T", " ", "Y", "U", "I", "O", "P", "[", "]", "\\", "sin()", "exp()", "^", "4", "5", "6", "*" },
           { " ", "cl", "cl", "A", "S", "D", "F", "G", " ", "H", "J", "K", "L", ";", "'", "en", "en", "cos()", "log()", "pi", "1", "2", "3", "-" },
           { " ", "ls", "ls", "Z", "X", "C", "V", "B", " ", "N", "M", ",", ".", "/", "rs", "rs", " ", "tan()", "log10()", "sqrt()", "0", " ", ".", "+" } };

static string lcskeys[4][9] = { { " ", "~", "!", "@", "#", "$", "%", "^", " " },
            { " ", "     ", "     ", "q", "w", "e", "r", "t", " " },
            { " ", "cl", "cl", "a", "s", "d", "f", "g", " " },
            { " ", "ls", "ls", "z", "x", "c", "v", "b", " " } };
          
static string rcskeys[4][16] = { { " ", "&", "*", "(", ")", "_", "+", "bs", "bs", "fact()", "(", ")", "7", "8", "9", "/" },
            { " ", "y", "u", "i", "o", "p", "{", "}", "|", "sin()", "exp()", "^", "4", "5", "6", "*" },
            { " ", "h", "j", "k", "l", ":", "\"", "en", "en", "cos()", "log()", "pi", "1", "2", "3", "-" },
            { " ", "n", "m", "<", ">", "?", "rs", "rs", " ", "tan()", "log10()", "sqrt()", "0", " ", ".", "+" } };
			
static string cskeys[4][24] = { { " ", "~", "!", "@", "#", "$", "%", "^", " ", "&", "*", "(", ")", "_", "+", "bs", "bs", "fact()", "(", ")", "7", "8", "9", "/" },
            { " ", "     ", "     ", "q", "w", "e", "r", "t", " ", "y", "u", "i", "o", "p", "{", "}", "|", "sin()", "exp()", "^", "4", "5", "6", "*" },
            { " ", "cl", "cl", "a", "s", "d", "f", "g", " ", "h", "j", "k", "l", ":", "\"", "en", "en", "cos()", "log()", "pi", "1", "2", "3", "-" },
            { " ", "ls", "ls", "z", "x", "c", "v", "b", " ", "n", "m", "<", ">", "?", "rs", "rs", " ", "tan()", "log10()", "sqrt()", "0", " ", ".", "+" } };


extern SDL_Surface *img_text, *img_background, *img_arrow, *img_arrows, *img_dirbuttons, *img_editbuttons, *img_check, *img_doc, *img_dot, *img_folder, *img_music, *img_pic, *img_space, *screen;
extern SDL_Surface *img_rckeys, *img_lckeys, *img_lcskeys, *img_rcskeys, *img_lkeys, *img_rkeys, *img_lskeys, *img_rskeys, *img_calckeys;
extern SDL_Surface *img_textbackground, *img_menubar, *tmp, *img_view, *img_test;
SDL_Surface *img_addressbookicon, *img_fileicon, *img_calendaricon, *img_calculatoricon, *img_notepadicon, *img_musicicon, *img_photoicon, *img_clockicon, *img_settingsicon;
extern SDL_Color sdlwhite;
extern SDL_Color sdlblack;
extern SDL_Color sdlgrey;
extern SDL_Color sdldarkgrey;
extern SDL_Color sdlred;
extern SDL_Color sdlgreen;
extern SDL_Color sdlblue;
extern SDL_Color forecol, fgcol, bgcol;
extern Uint32 backcol, white, black, grey, lightgrey, darkgrey, red, green, blue, cursorcol;
extern SDL_Rect dest;
extern TTF_Font *font, *drawfont, *drawfont10, *drawfont12, *drawfont14, *drawfont16, *drawfont20, *drawfont50, *systemfont;
extern int ndCol, ndLine, nFontsize, minlines, maxlines, menu, menumode, mode; 


extern codecStubs stubs[100];
extern int codecnum;
extern char *audiofile;
extern codecStubs *decoder;
extern int codec;

SceIoDirent g_dir;
extern vector <Dir> dir;
extern vector <string> dirimage;
extern vector <string> diraudio;
extern vector <string> playlist; 
//vector <string> themedir;

extern int nDir;
extern bool bmUpdate, isplaying, ispaused, shuffled;
extern bool transition;
extern int ly, lx, ry, rx;
extern int wait, nMaxchar, nKeyset, nCol, nLine;
extern SceCtrlData pad;
extern SceCtrlLatch latch;
extern u32 state;
extern int waitanalog, waitdigital, waitpress;

vector <string> settings;
string theme, path;

SDL_Surface *img_topborder, *img_sideborder, *img_bottomborder, *img_buttongroup1a, *img_buttongroup2a;
bool caps = false, shift = false;

struct p_sp_Key newKey;

bool padLeft(void) {
	if (nKeyset == 1) {
		if (pad.Buttons & PSP_CTRL_LEFT) return true;
	}
	if (nKeyset == 2 || nKeyset == 3 || nKeyset == 4) {
		if (pad.Lx == 0) return true;
	}
	return false;
}

bool padRight(void) {
	if (nKeyset == 1) {
		if (pad.Buttons & PSP_CTRL_RIGHT) return true;
	}
	if (nKeyset == 2 || nKeyset == 3 || nKeyset == 4) {
		if (pad.Lx == 255) return true;
	}
	return false;
}

bool padUp(void) {
	if (nKeyset == 1) {
		if (pad.Buttons & PSP_CTRL_UP) return true;
	}
	if (nKeyset == 2 || nKeyset == 3 || nKeyset == 4) {
		if (pad.Ly == 0) return true;
	}
	return false;
}

bool padDown(void) {
	if (nKeyset == 1) {
		if (pad.Buttons & PSP_CTRL_DOWN) return true;
	}
	if (nKeyset == 2 || nKeyset == 3 || nKeyset == 4) {
		if (pad.Ly == 255) return true;
	}
	return false;
}

void readKeyboard(void) 
{
	if (mode != CALCULATOR)
	{
		if (lx > 16) lx = 16;
		if (rx > 15) rx = 15;
	}
	if (nKeyset == 1) {
		if (pad.Ly == 0) {
			ly = ly - 1;
			if (ly < 0) ly = 3;
			wait = waitanalog;
			bmUpdate = true;
		}
		if (pad.Ly == 255) {
			ly = ly + 1;
			if (ly > 3) ly = 0;
			wait = waitanalog;
			bmUpdate = true;
		}
		if (pad.Lx == 0) {
			lx = lx - 1;
			if (mode != CALCULATOR)
			{
				if (lx < 0) lx = 16;
			}
			else if (lx < 0) lx = 23;
			wait = waitanalog;
			bmUpdate = true;
		}
		if (pad.Lx == 255) {
			lx = lx + 1;
			if (mode != CALCULATOR)
			{
				if (lx > 16) lx = 0;
			}
			else if (lx > 23) lx = 0;
			wait = waitanalog;
			bmUpdate = true;
		}
		if (pad.Buttons & PSP_CTRL_CROSS) {
			if (loc_keys[ly][lx] == "cl") {
				caps = !caps;
				wait = 100;
			}
			if (loc_keys[ly][lx] == "ls") {
				shift = !shift;
				wait = 100;
			}
			if (loc_keys[ly][lx] == "rs") {
				shift = !shift;
				wait = 100;
			}
			bmUpdate = true;
		}
	}
	if (nKeyset == 3 && !transition) {
		if (pad.Buttons & PSP_CTRL_UP) {
			ly = ly - 1;
			if (ly < 0) ly = 3;
			wait = waitdigital;
			bmUpdate = true;
		}
		if (pad.Buttons & PSP_CTRL_DOWN) {
			ly = ly + 1;
			if (ly > 3) ly = 0;
			wait = waitdigital;
			bmUpdate = true;
		}
		if (pad.Buttons & PSP_CTRL_LEFT) {
			lx = lx - 1;
			if (lx < 0) lx = 8;
			wait = waitdigital;
			bmUpdate = true;
		}
		if (pad.Buttons & PSP_CTRL_RIGHT) {
			lx = lx + 1;
			if (lx > 8) lx = 0;
			wait = waitdigital;
			bmUpdate = true;
		}
		if (pad.Buttons & PSP_CTRL_TRIANGLE) {
			ry = ry - 1;
			if (ry < 0) ry = 3;
			wait = waitdigital;
			bmUpdate = true;
		}
		if (pad.Buttons & PSP_CTRL_CROSS) {
			ry = ry + 1;
			if (ry > 3) ry = 0;
			wait = waitdigital;
			bmUpdate = true;
		}
		if (pad.Buttons & PSP_CTRL_SQUARE) {
			rx = rx - 1;
			if (mode != CALCULATOR)
			{
				if (rx < 0) rx = 8;
			}
			else if (rx < 0) rx = 15;
			wait = waitdigital;
			bmUpdate = true;
		}
		if (pad.Buttons & PSP_CTRL_CIRCLE) {
			rx = rx + 1;
			if (mode != CALCULATOR)
			{
				if (rx > 8) rx = 0;
			}
			else if (rx > 15) rx = 0;
			wait = waitdigital;
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_RTRIGGER)
			if (rkeys[ry][rx] == "rs") {
			shift = !shift;
			wait = 100;
			bmUpdate = true;
			}
		
		if (pad.Buttons & PSP_CTRL_LTRIGGER) {
			if (lkeys[ly][lx] == "cl") {
				caps = !caps;
				wait = 100;
			}
			if (lkeys[ly][lx] == "ls") {
				shift = !shift;
				wait = 100;
			}
			bmUpdate = true;
		}
	}
	if (nKeyset == 2 && !transition) {
		if (pad.Buttons & PSP_CTRL_UP) {
			ly = ly - 1;
			if (ly < 0) ly = 3;
			wait = waitdigital;
			bmUpdate = true;
		}
		if (pad.Buttons & PSP_CTRL_DOWN) {
			ly = ly + 1;
			if (ly > 3) ly = 0;
			wait = waitdigital;
			bmUpdate = true;
		}
		if (pad.Buttons & PSP_CTRL_LEFT) {
			lx = lx - 1;
			if (mode != CALCULATOR)
			{
				if (lx < 0) lx = 16;
			}
			else if (lx < 0) lx = 23;
			wait = waitdigital;
			bmUpdate = true;
		}
		if (pad.Buttons & PSP_CTRL_RIGHT) {
			lx = lx + 1;
			if (mode != CALCULATOR)
			{
				if (lx > 16) lx = 0;
			}
			else if (lx > 23) lx = 0;
			wait = waitdigital;
			bmUpdate = true;
		}
		if (pad.Buttons & PSP_CTRL_CROSS) {
			if (loc_keys[ly][lx] == "cl") {
				caps = !caps;
				wait = 100;
			}
			if (loc_keys[ly][lx] == "ls") {
				shift = !shift;
				wait = 100;
			}
			if (loc_keys[ly][lx] == "rs") {
				shift = !shift;
				wait = 100;
			}
			bmUpdate = true;
		}
	}	
}

string readKey(void) 
{
# ifdef USE_PSP_IRKEYB
  int irkeyb_key = psp_irkeyb_read_key();
  if (irkeyb_key != PSP_IRKEYB_EMPTY) {
    if (irkeyb_key == 0xd) {
      return "en";
    } else 
    if (irkeyb_key == 0x8) {
      return "bs";
    } else
    if (irkeyb_key >= ' ') {
      return string(1, (char)irkeyb_key);
    }
  } 
# endif
	if ((nKeyset == 1 || nKeyset == 2) && !transition) 
  {
		if (pad.Buttons & PSP_CTRL_CROSS) {
			bmUpdate = true;
			wait = waitpress;
			if (loc_keys[ly][lx] == "ls" || loc_keys[ly][lx] == "cl" || loc_keys[ly][lx] == "rs") return "";
			if (!shift && !caps) return loc_keys[ly][lx];
			if (shift && !caps) {
				if (loc_keys[ly][lx] != "en" && loc_keys[ly][lx] != "bs" && loc_keys[ly][lx] != "     " && loc_keys[ly][lx] != " ") shift = false;
				return skeys[ly][lx];
			}
			if (caps && !shift) return ckeys[ly][lx];
			if (caps && shift) {
				if (loc_keys[ly][lx] != "en" && loc_keys[ly][lx] != "bs" && loc_keys[ly][lx] != "     " && loc_keys[ly][lx] != " ") shift = false;
				return cskeys[ly][lx];
			}
		}
		if (pad.Buttons & PSP_CTRL_CIRCLE) {
			bmUpdate = true;
			wait = 120;
			return " ";
		}
		if (pad.Buttons & PSP_CTRL_LTRIGGER) {
			bmUpdate = true;
			wait = 120;
			return "bs";
		}
		if (pad.Buttons & PSP_CTRL_RTRIGGER) {
			bmUpdate = true;
			wait = 120;
			return "en";
		}
		if (pad.Buttons & PSP_CTRL_TRIANGLE) {
			bmUpdate = true;
			caps = !caps;
			wait = 200;
		}
		if (pad.Buttons & PSP_CTRL_SQUARE) {
			bmUpdate = true;
			shift = !shift;
			wait = 200;
		}					
	}
	if (nKeyset == 3 && !transition) {
		if (pad.Buttons & PSP_CTRL_LTRIGGER) {
			bmUpdate = true;
			wait = waitpress;
			if (lkeys[ly][lx] == "ls" || lkeys[ly][lx] == "cl") return "";
			if (!shift && !caps) return lkeys[ly][lx];
			if (shift && !caps) {
				if (lkeys[ly][lx] != "     " && lkeys[ly][lx] != " ") shift = false;
				return lskeys[ly][lx];
			}
			if (caps && !shift) return lckeys[ly][lx];
			if (caps && shift) {
				if (lkeys[ly][lx] != "     " && lkeys[ly][lx] != " ") shift = false;
				return lcskeys[ly][lx];
			}
		}
		if (pad.Buttons & PSP_CTRL_RTRIGGER) {
			bmUpdate = true;
			wait = waitpress;
			if (rkeys[ry][rx] == "rs") return "";
			if (!shift && !caps) return rkeys[ry][rx];
			if (shift && !caps) {
				if (rkeys[ry][rx] != "bs" && rkeys[ry][rx] != "en") shift = false;
				return rskeys[ry][rx];
			}
			if (caps && !shift) return rckeys[ry][rx];
			if (caps && shift) {
				if (rkeys[ry][rx] != "bs" && rkeys[ry][rx] != "en") shift = false;
				return rcskeys[ry][rx];
			}
		}
	}
	if (nKeyset == 4 && !transition)
	{
		string str;
		char i[3];
		int ch;
		

		if (pad.Buttons & PSP_CTRL_LTRIGGER) 
		{
			bmUpdate = true;
			wait = 120;
			return "     ";		
		}
		else if (pad.Buttons & PSP_CTRL_RTRIGGER) 
		{
			bmUpdate = true;
			wait = 120;
			return "en";
		}
		else if (pad.Buttons & PSP_CTRL_START)
		{
			return "";
		}
		else if (pad.Buttons & PSP_CTRL_SELECT)
		{
			return "";
		}
		
		else if (p_spReadKeyEx(&newKey,pad.Buttons))
		{
			ch = newKey.keycode;
			if (ch == 27) return "";
			else if (ch == 8) return "bs";
			else if (ch == 9) return "     ";
			else if (ch == 13) return "en";			
			else if (ch >= 16 && ch <= 20) return "";
			else if (ch >= 33 && ch <= 40) return "";
			else if (ch >= 44 && ch <= 46) return "";
			else if (ch == 106) return "*";
			else if (ch == 107) return "+";
			else if (ch == 109) return "-";
			else if (ch == 111) return "/";
			else if (ch >= 112 && ch <= 123) return "";
			else if (ch == 19 || ch == 144 || ch == 145 || ch == 91 || ch == 92) return "";
			ch = newKey.keychar;
			str = ch;
			return str;
		}
		
	}
	return "";
}

bool is_image(string file) {
	string extension;
	int findlast;
	
	findlast = file.find_last_of(".");
	
	if (findlast != string::npos) extension = file.substr(findlast+1,3);
	if (extension == "BMP" || extension == "bmp" || extension == "GIF" || extension == "gif" || 
		extension == "JPG" || extension == "jpg" || extension == "PNG" || extension == "png" ||
		extension == "TGA" || extension == "tga")
		return true;
	else return false;
}

bool is_audio(string file) {
	string extension;
	int findlast;
	
	findlast = file.find_last_of(".");
	
	if (findlast != string::npos) extension = file.substr(findlast+1,3);
	if (extension == "MP3" || extension == "mp3" || extension == "AAC" || extension == "aac" || 
		extension == "OGG" || extension == "ogg" || extension == "XM" || extension == "xm" ||
		extension == "MOD" || extension == "mod")
		return true;
	else return false;
}

bool is_exec(string file) {
	string extension;
	int findlast;
	
	findlast = file.find_last_of(".");
	
	if (findlast != string::npos) extension = file.substr(findlast+1,3);
	if (extension == "PBP" || extension == "pbp")
		return true;
	else return false;
}

void listThemeDirectory(vector <string> &themedir) {
	Dir tmpdir;
	
	int fd = sceIoDopen("image");
	themedir.clear();
	while (sceIoDread(fd, &g_dir) > 0) {
		tmpdir.name = g_dir.d_name;
		tmpdir.isDir = g_dir.d_stat.st_attr & FIO_SO_IFDIR;
		
		if (tmpdir.isDir) {
			if (tmpdir.name != "." && tmpdir.name != "..") themedir.push_back(tmpdir.name);
		}
	}
	
	sceIoDclose(fd);
	
	sort(themedir.begin(), themedir.end());
}
	

void listDirectory(string path) {
	int count;
	Dir tmpdir;
	vector <string> dirdir;
	vector <string> dirfile;
	
	int fd = sceIoDopen(path.c_str());
	dir.clear();
	while (sceIoDread(fd, &g_dir) > 0) {
		tmpdir.name = g_dir.d_name;
		tmpdir.isDir = g_dir.d_stat.st_attr & FIO_SO_IFDIR;
		
		if (tmpdir.isDir) {
			if (tmpdir.name != ".") dirdir.push_back(tmpdir.name);
		}
		else {
			dirfile.push_back(tmpdir.name);
		}
	}
	
	sceIoDclose(fd);
	
	sort(dirdir.begin(), dirdir.end());
	sort(dirfile.begin(), dirfile.end());
	
	for (count = 0; count < dirdir.size(); count++) {
		tmpdir.name = dirdir.at(count);
		tmpdir.isDir = 1;
		dir.push_back(tmpdir);
	}
	
	for (count = 0; count < dirfile.size(); count++) {
		tmpdir.name = dirfile.at(count);
		tmpdir.isDir = 0;
		dir.push_back(tmpdir);
	}	
}

void listAudioDirectory(string path, int flag) {
	Dir tmpdir;
	
	int fd = sceIoDopen(path.c_str());
	if (flag == 0) diraudio.clear();
	while (sceIoDread(fd, &g_dir) > 0) {
		tmpdir.name = g_dir.d_name;
		tmpdir.isDir = g_dir.d_stat.st_attr & FIO_SO_IFDIR;
		
		if (!tmpdir.isDir) {
			if (is_audio(tmpdir.name) && flag == 0) diraudio.push_back(path + "/" + tmpdir.name);
			if (is_audio(tmpdir.name) && flag == 1) playlist.push_back(path + "/" + tmpdir.name);
		}
		else if (tmpdir.name != "." && tmpdir.name != ".." && flag == 1)
		{
			listAudioDirectory(path + "/" + tmpdir.name, flag);
		}
	}
	
	sceIoDclose(fd);
	
	if (flag == 0)
	{
		if (shuffled) random_shuffle(diraudio.begin(), diraudio.end());
		else sort(diraudio.begin(), diraudio.end());
	}
	if (flag == 1)
	{
		if (shuffled) random_shuffle(playlist.begin(), playlist.end());
		else sort(playlist.begin(), playlist.end());
	}	
}

void load_play(const char* file) {
    //determine codec of the file
    for (codec = 0; codec <= codecnum; codec++) {
	char *ptr = &(stubs[codec].extension[0]);
	while (*ptr != 0) {
	    if (strncasecmp(&file[strlen(file) - 3], ptr, 3) == 0) {
		decoder = &stubs[codec];
		break;
	    }
	    ptr += 4;
	}
    }
		
    decoder->init(0);
    if (decoder->load(file)) {
	decoder->play(); }
}

void drawFillRect(SDL_Surface* surface, int x0,int y0, int w, int h, Uint32 color) {
	SDL_Rect rect;
	
	rect.x = x0;
	rect.y = y0;
	rect.w = w;
	rect.h = h;
	SDL_FillRect(surface, &rect, color);
}

void drawHline(SDL_Surface* surface, int x0, int y0, int w, Uint32 color) {
	SDL_Rect rect;
	
	rect.x = x0;
	rect.y = y0;
	rect.w = w;
	rect.h = 1;
	SDL_FillRect(surface, &rect, color);
}

void drawVline(SDL_Surface* surface, int x0, int y0, int h, Uint32 color) {
	SDL_Rect rect;
	
	rect.x = x0;
	rect.y = y0;
	rect.w = 1;
	rect.h = h;
	SDL_FillRect(surface, &rect, color);
}

void drawDropmenu(SDL_Surface* surface, int x0, int y0, int nChar, int nList) {
	drawFillRect(surface,x0,y0,nChar*nCol+nCol*4,nList*nLine+nLine/2,white);
	drawRect(surface,x0,y0,nChar*nCol+nCol*4,nList*nLine+nLine/2,darkgrey);
	drawRect(surface,x0+1,y0+1,nChar*nCol+nCol*4,nList*nLine+nLine/2,black);
	drawRect(surface,x0+2,y0+2,nChar*nCol+nCol*4,nList*nLine+nLine/2,darkgrey);
	drawRect(surface,x0+3,y0+3,nChar*nCol+nCol*4,nList*nLine+nLine/2,grey);
	drawRect(surface,x0+4,y0+4,nChar*nCol+nCol*4,nList*nLine+nLine/2,lightgrey);
}

void drawFrame(SDL_Surface* surface, int x0, int y0, int w, int h) {
	SDL_Rect rect;
	
	//if (bUpdate) drawFillRect(surface,x0,y0,w,h,backcol);
	
	rect.x = x0;rect.y = y0;rect.w = w-2;rect.h = 8;
	SDL_FillRect(surface,&rect, grey); // top bar
	
	rect.x = x0+3;rect.y = y0+7;rect.w = w-6;rect.h = 1;
	SDL_FillRect(surface,&rect,darkgrey); // top line
	
	rect.x = x0;rect.y = y0;rect.w = 4;rect.h = h-1;
	SDL_FillRect(surface,&rect,grey); // left bar
	
	rect.x = x0+3;rect.y = y0+8;rect.w = 1;rect.h = h-6-8;
	SDL_FillRect(surface,&rect,darkgrey); // left line
	rect.x = x0+w-4;rect.y = y0;rect.w = 4;rect.h = h-1;
	SDL_FillRect(surface,&rect,grey); // right bar
	
	rect.x = x0+w-2;rect.y = y0+2;rect.w = 2;rect.h = h-2;
	SDL_FillRect(surface,&rect,darkgrey); // right line
	
	rect.x = x0;rect.y = y0+h-8;rect.w = w-2;rect.h = 6;
	SDL_FillRect(surface,&rect,grey); // bottom bar
	
	rect.x = x0+2;rect.y = y0+h-2;rect.w = w-2;rect.h = 2;
	SDL_FillRect(surface,&rect,darkgrey); // bottom line
	
	rect.x = x0+3;rect.y = y0+h-8;rect.w = w-4-3;rect.h = 1;
	SDL_FillRect(surface,&rect,lightgrey);
}

void drawKeyboard(SDL_Surface *surface) {
	if (nKeyset != 4)
	{
		if (!shift and !caps and !shift) {
			sge_Blit(img_lkeys, surface, 0,0,70,200,img_lkeys->w, img_lkeys->h);
			sge_Blit(img_rkeys, surface, 0,0,250,200,img_rkeys->w, img_rkeys->h);
		}
		if ((shift or shift) and !caps) {
			sge_Blit(img_lskeys, surface, 0,0,70,200,img_lskeys->w, img_lskeys->h);
			sge_Blit(img_rskeys, surface, 0,0,250,200,img_rskeys->w, img_rskeys->h);
		}
		if (caps and !shift and !shift) {	
			sge_Blit(img_lckeys, surface, 0,0,70,200,img_lckeys->w, img_lckeys->h);
			sge_Blit(img_rckeys, surface, 0,0,250,200,img_rckeys->w, img_rckeys->h);
		}
		if ((shift or shift) and caps) {
			sge_Blit(img_lcskeys, surface, 0,0,70,200,img_lcskeys->w, img_lcskeys->h);
			sge_Blit(img_rcskeys, surface, 0,0,250,200,img_rcskeys->w, img_rcskeys->h);
		}
		sge_Blit(img_space, surface, 0,0, 230, 200, img_space->w, img_space->h);
		drawRect(surface, 70 + (lx) * 20, 200 + (ly) * 18, 20, 18, blue);
		if (nKeyset == 3) drawRect(surface, 230 + (rx) * 20, 200 + (ry) * 18, 20, 18, red);
	}
	if (nKeyset == 4)
	{
		if (newKey.keygroup == 0) blit(surface, 138, 200,img_buttongroup1a);
		if (newKey.keygroup == 1) blit(surface, 138, 200,img_buttongroup2a);
	}
}

void drawMenuFrame(SDL_Surface* surface) {
	SDL_Rect rect;
	rect.x = 25;
	rect.y = 30;
	rect.w = 440;
	rect.h = 148;
	//SDL_FillRect(surface,&rect,black); // drop shadow
	
	
	rect.x = 20;
	rect.y = 17;
	rect.w = 440;
	rect.h = 10;
	//SDL_FillRect(surface,&rect,grey); // top bar
	blit(surface,20,15,img_topborder);
	rect.x = 20;
	rect.y = 17;
	rect.w = 460-20;
	rect.h = 1;
	//SDL_FillRect(surface,&rect,lightgrey); // very top line
	rect.x = 20;
	rect.y = 20;
	rect.w = 8;
	rect.h = 146;
	//SDL_FillRect(surface,&rect,grey); // left bar
	blit(surface,20,27,img_sideborder);
	rect.x = 452;
	rect.y = 20;
	rect.w = 8;
	rect.h = 147;
	//SDL_FillRect(surface,&rect,grey); // right bar
	blit(surface,452,27,img_sideborder);
	rect.x = 20;
	rect.y = 160;
	rect.w = 440;
	rect.h = 8;
	//SDL_FillRect(surface,&rect,grey); // bottom bar
	blit(surface,20,160,img_bottomborder);
	rect.x = 25;
	rect.y = 28;
	rect.w = 1;
	rect.h = 160-28;
	SDL_FillRect(surface,&rect,darkgrey); // left line
	drawHline(surface,26,160,454-26,darkgrey);
	drawFillRect(surface,26,27,428,133,white);
	rect.x = 26;
	rect.y = 27;
	rect.w = 454-26;
	rect.h = 1;
	SDL_FillRect(surface,&rect,lightgrey); // top line	
}


void drawRect(SDL_Surface* surface, int x0, int y0, int w, int h, Uint32 color) {
	SDL_Rect rect;
	rect.x = x0;
	rect.y = y0;
	rect.w = w;
	rect.h = 1;
	SDL_FillRect(surface,&rect,color);
	rect.x = x0;
	rect.y = y0;
	rect.w = 1;
	rect.h = h;
	SDL_FillRect(surface,&rect,color);
	rect.x = x0+w - 1;
	rect.y = y0;
	rect.w = 1;
	rect.h = h;
	SDL_FillRect(surface,&rect,color);
	rect.x = x0;
	rect.y = y0+h - 1;
	rect.w = w;
	rect.h = 1;
	SDL_FillRect(surface,&rect,color); 
}


void loadSettings(void) {
	SDL_Color bgcol;
	string readline;
	Sint32 loc;
	ifstream file("settings.ini");
		
	settings.clear();
	while (getline(file,readline,'\n')) {
		
		loc = readline.find((char) 13,0);
		if (loc != string::npos) readline.resize(readline.size()-1);
		settings.push_back(readline);
	}
	file.close();

	nKeyset = atoi(settings[1].c_str());
	nFontsize = atoi(settings[2].c_str());
	

	bgcol.r = atoi(settings[3].c_str());
	bgcol.g = atoi(settings[4].c_str());
	bgcol.b = atoi(settings[5].c_str());
	backcol = SDL_MapRGB(screen->format,bgcol.r,bgcol.g,bgcol.b);
	forecol.r = atoi(settings[6].c_str());
	forecol.g = atoi(settings[7].c_str());
	forecol.b = atoi(settings[8].c_str());
	waitanalog = atoi(settings[9].c_str());
	waitdigital = atoi(settings[10].c_str());
	waitpress = atoi(settings[11].c_str());
	theme = settings[12];
	
	string cstring = "image/" + theme + "/lucon.ttf";
	font = TTF_OpenFont(cstring.c_str(), 12);
	drawfont = TTF_OpenFont(cstring.c_str(), 12);
	drawfont16 = TTF_OpenFont(cstring.c_str(), 16);
	drawfont20 = TTF_OpenFont(cstring.c_str(),60);
	drawfont50 = TTF_OpenFont(cstring.c_str(), 100);
	systemfont = TTF_OpenFont(cstring.c_str(),10);

	setBounds(nFontsize);
}


void saveSettings(void) {
	ofstream writefile;
	SDL_Color bgcol;
	char input[3];
	int count;
	
	SDL_GetRGB(backcol, screen->format,&bgcol.r, &bgcol.g, &bgcol.b);
	sprintf(input,"%d",nKeyset);
	settings[1] = input;
	sprintf(input,"%d",nFontsize);
	settings[2] = input;
	sprintf(input,"%d",bgcol.r);
	settings[3] = input;
	sprintf(input,"%d",bgcol.g);
	settings[4] = input;
	sprintf(input,"%d",bgcol.b);
	settings[5] = input;
	sprintf(input,"%d",forecol.r);
	settings[6] = input;
	sprintf(input,"%d",forecol.g);
	settings[7] = input;
	sprintf(input,"%d",forecol.b);
	settings[8] = input;
	sprintf(input,"%d",waitanalog);
	settings[9] = input;
	sprintf(input,"%d",waitdigital);
	settings[10] = input;
	sprintf(input,"%d",waitpress);
	settings[11] = input;
	settings[12] = theme;
	writefile.open("settings.ini");
	for (count = 0; count < settings.size(); count++) {		
		writefile << settings[count] << endl;
	}
	writefile.close();
}

void reloadFonts(void) {
	if (menu > 0) {
// || menumode > 0 || (mode < KEYBOARD && mode > FULLSCREEN)) {
		TTF_CloseFont(font);
		TTF_CloseFont(drawfont);
		TTF_CloseFont(drawfont16);
		TTF_CloseFont(drawfont20);
		TTF_CloseFont(drawfont50);
		TTF_CloseFont(systemfont);
		TTF_Quit();
		TTF_Init();
		
		string cstring = "image/" + theme + "/lucon.ttf";
		font = TTF_OpenFont(cstring.c_str(), 12);
		drawfont = TTF_OpenFont(cstring.c_str(), 12);
		drawfont16 = TTF_OpenFont(cstring.c_str(), 16);
		drawfont20 = TTF_OpenFont(cstring.c_str(),60);
		drawfont50 = TTF_OpenFont(cstring.c_str(), 100);
		systemfont = TTF_OpenFont(cstring.c_str(),10);
		setBounds(nFontsize);
	}
}

void setBounds(int fontsize) {
	string cstring = "image/" + theme + "/lucon.ttf";
	if (fontsize == 10) {
		nMaxchar = 79;
		ndCol = 6;
		ndLine = 10;
		minlines = 18;
		maxlines = 25;
		TTF_CloseFont(drawfont);
		drawfont = TTF_OpenFont(cstring.c_str(), 10);
	}
	if (fontsize == 12) {
		nMaxchar = 67;
		ndCol = 7;
		ndLine = 12;
		minlines = 15;
		maxlines = 21;
		TTF_CloseFont(drawfont);
		drawfont = TTF_OpenFont(cstring.c_str(), 12);
	}
	if (fontsize == 14) {
		nMaxchar = 59;
		ndCol = 8;
		ndLine = 14;
		minlines = 13;
		maxlines = 18;
		TTF_CloseFont(drawfont);
		drawfont = TTF_OpenFont(cstring.c_str(), 14);
	}
	if (fontsize == 16) {
		nMaxchar = 47;
		ndCol = 10;
		ndLine = 16;
		minlines = 11;
		maxlines = 16;
		TTF_CloseFont(drawfont);
		drawfont = TTF_OpenFont(cstring.c_str(), 16);
	}
}


void set_colors(SDL_PixelFormat* format)
{
	backcol = SDL_MapRGB(format,255,255,255);
	red = SDL_MapRGB(format,255,0,0);
	green = SDL_MapRGB(format,0,255,0);
	blue = SDL_MapRGB(format,0,0,255);
	white = SDL_MapRGB(format,255,255,255);
	black = SDL_MapRGB(format,0,0,0);
	lightgrey = SDL_MapRGB(format,224,224,224);
	grey = SDL_MapRGB(format,200,200,200);
	darkgrey = SDL_MapRGB(format,125,125,125);
}

int 
load_gfx(void)
{
	SDL_Surface *tmp;
	string cstring;
	
	if (img_background) SDL_FreeSurface(img_background);
	cstring = "image/" + theme + "/metal.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/metal.png"); return -1;}
	img_background=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	
	if (img_arrow) SDL_FreeSurface(img_arrow);
	cstring = "image/" + theme + "/arrow.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/arrow.png"); return -1;}
	img_arrow=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	if (img_arrows) SDL_FreeSurface(img_arrows);
	cstring = "image/" + theme + "/arrows.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/arrows.png"); return -1;}
	img_arrows=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	
	if (img_editbuttons) SDL_FreeSurface(img_editbuttons);
	cstring = "image/" + theme + "/editbuttons.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/editbuttons.png"); return -1;}
	img_editbuttons=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	if (img_check) SDL_FreeSurface(img_check);
	cstring = "image/" + theme + "/check.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/check.png"); return -1;}
	img_check=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	if (img_lckeys) SDL_FreeSurface(img_lckeys);
	cstring = "image/" + theme + "/cleft.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/cleft.png"); return -1;}
	img_lckeys=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	if (img_rckeys) SDL_FreeSurface(img_rckeys);
	cstring = "image/" + theme + "/cright.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/cright.png"); return -1;}
	img_rckeys=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	if (img_lcskeys) SDL_FreeSurface(img_lcskeys);
	cstring = "image/" + theme + "/csleft.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/csleft.png"); return -1;}
	img_lcskeys=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	if (img_rcskeys) SDL_FreeSurface(img_rcskeys);
	cstring = "image/" + theme + "/csright.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/csright.png"); return -1;}
	img_rcskeys=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	if (img_doc) SDL_FreeSurface(img_doc);
	cstring = "image/" + theme + "/doc.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/doc.png"); return -1;}
	img_doc=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	if (img_dot) SDL_FreeSurface(img_dot);
	cstring = "image/" + theme + "/dot.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/dot.png"); return -1;}
	img_dot=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	if (img_folder) SDL_FreeSurface(img_folder);
	cstring = "image/" + theme + "/folder.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/folder.png"); return -1;}
	img_folder=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	
	if (img_music) SDL_FreeSurface(img_music);
	cstring = "image/" + theme + "/music.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/music.png"); return -1;}
	img_music=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	
	if (img_pic) SDL_FreeSurface(img_pic);
	cstring = "image/" + theme + "/pic.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/pic.png"); return -1;}
	img_pic=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	if (img_lkeys) SDL_FreeSurface(img_lkeys);
	cstring = "image/" + theme + "/left.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/left.png"); return -1;}
	img_lkeys=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	if (img_rkeys) SDL_FreeSurface(img_rkeys);
	cstring = "image/" + theme + "/right.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/right.png"); return -1;}
	img_rkeys=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	if (img_lskeys) SDL_FreeSurface(img_lskeys);
	cstring = "image/" + theme + "/sleft.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/sleft.png"); return -1;}
	img_lskeys=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	if (img_space) SDL_FreeSurface(img_space);
	cstring = "image/" + theme + "/space.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/space.png"); return -1;}
	img_space=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	if (img_rskeys) SDL_FreeSurface(img_rskeys);
	cstring = "image/" + theme + "/sright.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/sright.png"); return -1;}
	img_rskeys=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	if (img_textbackground) SDL_FreeSurface(img_textbackground);
	cstring = "image/" + theme + "/textbackground.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/textbackground.png"); return -1;}
	img_textbackground=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	
	if (img_topborder) SDL_FreeSurface(img_topborder);
	cstring = "image/" + theme + "/topborder.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/topborder.png"); return -1;}
	img_topborder=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	if (img_sideborder) SDL_FreeSurface(img_sideborder);
	cstring = "image/" + theme + "/sideborder.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/sideborder.png"); return -1;}
	img_sideborder=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	
	if (img_bottomborder) SDL_FreeSurface(img_bottomborder);
	cstring = "image/" + theme + "/bottomborder.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/bottomborder.png"); return -1;}
	img_bottomborder=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	
	if (img_addressbookicon) SDL_FreeSurface(img_addressbookicon);
	cstring = "image/" + theme + "/addressbookicon.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/addressbookicon.png"); return -1;}
	img_addressbookicon=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	
	if (img_fileicon) SDL_FreeSurface(img_fileicon);
	cstring = "image/" + theme + "/fileicon.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/fileicon.png"); return -1;}
	img_fileicon=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	
	if (img_calendaricon) SDL_FreeSurface(img_calendaricon);
	cstring = "image/" + theme + "/calendaricon.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/calendaricon.png"); return -1;}
	img_calendaricon=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	
	if (img_calculatoricon) SDL_FreeSurface(img_calculatoricon);
	cstring = "image/" + theme + "/calculatoricon.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/calculatoricon.png"); return -1;}
	img_calculatoricon=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	if (img_notepadicon) SDL_FreeSurface(img_notepadicon);
	cstring = "image/" + theme + "/notepadicon.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/notepadicon.png"); return -1;}
	img_notepadicon=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	if (img_musicicon) SDL_FreeSurface(img_musicicon);
	cstring = "image/" + theme + "/musicicon.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/musicicon.png"); return -1;}
	img_musicicon=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	
	if (img_photoicon) SDL_FreeSurface(img_photoicon);
	cstring = "image/" + theme + "/photoicon.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/photoicon.png"); return -1;}
	img_photoicon=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	
	if (img_clockicon) SDL_FreeSurface(img_clockicon);
	cstring = "image/" + theme + "/clockicon.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/clockicon.png"); return -1;}
	img_clockicon=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);

	if (img_settingsicon) SDL_FreeSurface(img_settingsicon);
	cstring = "image/" + theme + "/settingsicon.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/settingsicon.png"); return -1;}
	img_settingsicon=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	if (img_menubar) SDL_FreeSurface(img_menubar);
	cstring = "image/" + theme + "/menubar.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/menubar.png"); return -1;}
	img_menubar=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	
	if (img_calckeys) SDL_FreeSurface(img_calckeys);
	cstring = "image/" + theme + "/calckey.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/calckey.png"); return -1;}
	img_calckeys=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);

	if (img_buttongroup1a) SDL_FreeSurface(img_buttongroup1a);
	cstring = "image/" + theme + "/buttongroup1a.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/buttongroup1a.png"); return -1;}
	img_buttongroup1a=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	
	if (img_buttongroup2a) SDL_FreeSurface(img_buttongroup2a);
	cstring = "image/" + theme + "/buttongroup2a.png";
	tmp=IMG_Load(cstring.c_str());
	if(!tmp){SDL_SetError("Couldn't load image/buttongroup2a.png"); return -1;}
	img_buttongroup2a=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	

	return 0;
}


void drawText(TTF_Font* font,SDL_Surface* surface, int x, int y, string text, SDL_Color color) {
	SDL_Surface *tmp_text;
	if (text.size() > 0) 
	{		
		tmp_text = TTF_RenderText_Blended(font, text.c_str(), color);
		if (tmp_text) sge_Blit(tmp_text, surface, 0, 0, x, y, tmp_text->w, tmp_text->h);
		else 
		{
			reloadFonts();
			tmp_text = TTF_RenderText_Blended(font, text.c_str(), color);
			if (tmp_text) sge_Blit(tmp_text, surface, 0, 0, x, y, tmp_text->w, tmp_text->h);			
		}
		if (tmp_text) SDL_FreeSurface(tmp_text);
	}
}

void drawTextShadowed(TTF_Font* font,SDL_Surface* surface, int x, int y, string text, SDL_Color color) {
	SDL_Surface *tmp_text;
	
	if (text.size() > 0) {
		tmp_text = TTF_RenderText_Blended(font, text.c_str(), sdlblack);		
		if (tmp_text) sge_Blit(tmp_text, surface, 0, 0, x+1, y+1, tmp_text->w, tmp_text->h);
		else 
		{
			reloadFonts();
			tmp_text = TTF_RenderText_Blended(font, text.c_str(), sdlblack);		
			if (tmp_text) sge_Blit(tmp_text, surface, 0, 0, x+1, y+1, tmp_text->w, tmp_text->h);			
		}
		if (tmp_text) SDL_FreeSurface(tmp_text);
		tmp_text = TTF_RenderText_Blended(font, text.c_str(), color);		
		if (tmp_text) sge_Blit(tmp_text, surface, 0, 0, x, y, tmp_text->w, tmp_text->h);
		else 
		{
			reloadFonts();
			//tmp_text = TTF_RenderText_Blended(font, text.c_str(), color);		
			//if (tmp_text) sge_Blit(tmp_text, surface, 0, 0, x, y, tmp_text->w, tmp_text->h);			
		}
		if (tmp_text) SDL_FreeSurface(tmp_text);
	}
}



void blit(SDL_Surface * Dest, Sint16 DestX, Sint16 DestY, SDL_Surface * Src) {
	sge_Blit(Src,Dest, 0,0,DestX,DestY,Src->w,Src->h);
}

void initTimezone(void)
{
   int tzOffset = 0;
   sceUtilityGetSystemParamInt(PSP_SYSTEMPARAM_ID_INT_TIMEZONE, &tzOffset);
   int tzOffsetAbs = tzOffset < 0 ? -tzOffset : tzOffset;
   int hours = tzOffsetAbs / 60;
   int minutes = tzOffsetAbs - hours * 60;
   static char tz[10];
   sprintf(tz, "GMT%s%02i:%02i", tzOffset < 0 ? "+" : "-", hours, minutes);
   setenv("TZ", tz, 1);
   tzset();
} 

#ifdef KERNEL
int execute(SceSize args, void *argp)
{

	SceKernelLoadExecParam	execParam;
	const u32				total_length( path.size() + 1 );

	execParam.args = total_length;
	execParam.argp = const_cast< char * >( path.data() );	
	execParam.key = NULL;
	execParam.size = sizeof( execParam );
	sceKernelLoadExec( path.c_str(), &execParam );
	return 0;
}

//helper function to make things easier
int LoadStartModule(char *path)
{
    u32 loadResult;
    u32 startResult;
    int status;

    loadResult = sceKernelLoadModule(path, 0, NULL);
    if (loadResult & 0x80000000)
	return -1;
    else
	startResult =
	    sceKernelStartModule(loadResult, 0, NULL, &status, NULL);

    if (loadResult != startResult)
	return -2;

    return 0;
}

void loadUsbDrivers(void) {
	u32 retVal;
	
    //start necessary drivers
	LoadStartModule("flash0:/kd/loadexec.prx");
    LoadStartModule("flash0:/kd/semawm.prx");
    LoadStartModule("flash0:/kd/usbstor.prx");
    LoadStartModule("flash0:/kd/usbstormgr.prx");
    LoadStartModule("flash0:/kd/usbstorms.prx");
    LoadStartModule("flash0:/kd/usbstorboot.prx");

    //setup USB drivers
    retVal = sceUsbStart(PSP_USBBUS_DRIVERNAME, 0, 0);
    if (retVal != 0) {
	printf("Error starting USB Bus driver (0x%08X)\n", retVal);
	sceKernelSleepThread();
    }
    retVal = sceUsbStart(PSP_USBSTOR_DRIVERNAME, 0, 0);
    if (retVal != 0) {
	printf("Error starting USB Mass Storage driver (0x%08X)\n",
	       retVal);
	sceKernelSleepThread();
    }
    retVal = sceUsbstorBootSetCapacity(0x800000);
    if (retVal != 0) {
	printf
	    ("Error setting capacity with USB Mass Storage driver (0x%08X)\n",
	     retVal);
	sceKernelSleepThread();
    }
    retVal = 0;
}

/* Sets up the callback thread and returns its thread id */
int SetupExecute(string prog)
{
	int thid = 0;

	path = prog;
	thid = sceKernelCreateThread("execute", execute, 0x11, 0xFA0, 0, 0);
	if(thid >= 0)
	{
		sceKernelStartThread(thid, 0, 0);
	}

	return thid;
}
#endif /*KERNEL*/


